"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollectiblePedestalType = void 0;
/** Corresponds to the overlay frame number in "005.100_collectible.anm2". */
var CollectiblePedestalType;
(function (CollectiblePedestalType) {
    /**
     * Used for e.g. shop collectibles. In the "005.100_collectible.anm2" file, this is represented by
     * the final frame.
     */
    CollectiblePedestalType[CollectiblePedestalType["NONE"] = -1] = "NONE";
    /** The normal grey pedestal. */
    CollectiblePedestalType[CollectiblePedestalType["NORMAL"] = 0] = "NORMAL";
    /** From `SlotVariant.FORTUNE_TELLING_MACHINE` (3). */
    CollectiblePedestalType[CollectiblePedestalType["FORTUNE_TELLING_MACHINE"] = 1] = "FORTUNE_TELLING_MACHINE";
    /** From `SlotVariant.BLOOD_DONATION_MACHINE` (2). */
    CollectiblePedestalType[CollectiblePedestalType["BLOOD_DONATION_MACHINE"] = 2] = "BLOOD_DONATION_MACHINE";
    /** From `SlotVariant.SLOT_MACHINE` (1). */
    CollectiblePedestalType[CollectiblePedestalType["SLOT_MACHINE"] = 3] = "SLOT_MACHINE";
    /** From `PickupVariant.LOCKED_CHEST` (60). */
    CollectiblePedestalType[CollectiblePedestalType["LOCKED_CHEST"] = 4] = "LOCKED_CHEST";
    /** From `PickupVariant.RED_CHEST` (360). */
    CollectiblePedestalType[CollectiblePedestalType["RED_CHEST"] = 5] = "RED_CHEST";
    /** From `PickupVariant.BOMB_CHEST` (51). */
    CollectiblePedestalType[CollectiblePedestalType["BOMB_CHEST"] = 6] = "BOMB_CHEST";
    /** From `PickupVariant.SPIKED_CHEST` (52). */
    CollectiblePedestalType[CollectiblePedestalType["SPIKED_CHEST"] = 7] = "SPIKED_CHEST";
    /** From `PickupVariant.ETERNAL_CHEST` (53). */
    CollectiblePedestalType[CollectiblePedestalType["ETERNAL_CHEST"] = 8] = "ETERNAL_CHEST";
    /** From `SlotVariant.MOMS_DRESSING_TABLE` (12). */
    CollectiblePedestalType[CollectiblePedestalType["MOMS_DRESSING_TABLE"] = 9] = "MOMS_DRESSING_TABLE";
    /** From `PickupVariant.CHEST` (50). */
    CollectiblePedestalType[CollectiblePedestalType["CHEST"] = 10] = "CHEST";
    /** From `PickupVariant.MOMS_CHEST` (390). */
    CollectiblePedestalType[CollectiblePedestalType["MOMS_CHEST"] = 11] = "MOMS_CHEST";
    /** From `PickupVariant.OLD_CHEST` (55). */
    CollectiblePedestalType[CollectiblePedestalType["OLD_CHEST"] = 12] = "OLD_CHEST";
    /** From `PickupVariant.WOODEN_CHEST` (56). */
    CollectiblePedestalType[CollectiblePedestalType["WOODEN_CHEST"] = 13] = "WOODEN_CHEST";
    /** From `PickupVariant.MEGA_CHEST` (57). */
    CollectiblePedestalType[CollectiblePedestalType["MEGA_CHEST"] = 14] = "MEGA_CHEST";
})(CollectiblePedestalType || (exports.CollectiblePedestalType = CollectiblePedestalType = {}));
