"use strict";
/* eslint-disable sort-exports/sort-exports */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CageSubType = exports.MegaFattySubType = exports.GateSubType = exports.MegaMawSubType = exports.DingleSubType = exports.HauntSubType = exports.GurglingSubType = exports.WidowSubType = exports.GurdyJrSubType = exports.GeminiSubType = exports.FistulaSubType = exports.BloatSubType = exports.PeepSubType = exports.HuskSubType = exports.DukeOfFliesSubType = exports.DeathSubType = exports.WarSubType = exports.PestilenceSubType = exports.FamineSubType = exports.FrailSubType = exports.PinSubType = exports.MomSubType = exports.Monstro2SubType = exports.GurdySubType = exports.CarrionQueenSubType = exports.ChubSubType = exports.ChargerSubType = exports.MonstroSubType = exports.HollowSubType = exports.LarryJrSubType = exports.LaserSubType = exports.BedSubType = exports.TrinketType = exports.CardType = exports.CollectibleType = exports.BatterySubType = exports.PillColor = exports.SackSubType = exports.ChestSubType = exports.PoopPickupSubType = exports.BombSubType = exports.KeySubType = exports.CoinSubType = exports.HeartSubType = exports.PickupNullSubType = exports.BloodClotSubType = exports.DipFamiliarSubType = exports.BlueFlySubType = exports.BabySubType = exports.PlayerType = void 0;
exports.PurgatorySubType = exports.PortalTeleportSubType = exports.TallLadderSubType = exports.DiceFloorSubType = exports.CarpetSubType = exports.HeavenLightDoorSubType = exports.PoofSubType = exports.GibSubType = exports.BloodExplosionSubType = exports.MotherSubType = exports.ConstantStoneShooterSubType = exports.RagManSubType = exports.LittleHornSubType = exports.ForsakenSubType = exports.BrownieSubType = exports.StainSubType = exports.PolycephalusSubType = void 0;
/**
 * For `EntityType.PLAYER` (1), `PlayerVariant.PLAYER` (0).
 *
 * This is the sub-type of a player.
 *
 * Conventionally, variables that have this type are represented as "character" instead of
 * "playerType", since the former is more descriptive of what this value actually represents.
 */
var PlayerType;
(function (PlayerType) {
    /** Used in the secret Possessor Mode added in Repentance. */
    PlayerType[PlayerType["POSSESSOR"] = -1] = "POSSESSOR";
    PlayerType[PlayerType["ISAAC"] = 0] = "ISAAC";
    PlayerType[PlayerType["MAGDALENE"] = 1] = "MAGDALENE";
    PlayerType[PlayerType["CAIN"] = 2] = "CAIN";
    PlayerType[PlayerType["JUDAS"] = 3] = "JUDAS";
    PlayerType[PlayerType["BLUE_BABY"] = 4] = "BLUE_BABY";
    PlayerType[PlayerType["EVE"] = 5] = "EVE";
    PlayerType[PlayerType["SAMSON"] = 6] = "SAMSON";
    PlayerType[PlayerType["AZAZEL"] = 7] = "AZAZEL";
    PlayerType[PlayerType["LAZARUS"] = 8] = "LAZARUS";
    PlayerType[PlayerType["EDEN"] = 9] = "EDEN";
    PlayerType[PlayerType["LOST"] = 10] = "LOST";
    /** Lazarus Risen, from the Lazarus' Rags collectible. */
    PlayerType[PlayerType["LAZARUS_2"] = 11] = "LAZARUS_2";
    /** Dark Judas, from the Judas' Shadow collectible. */
    PlayerType[PlayerType["DARK_JUDAS"] = 12] = "DARK_JUDAS";
    PlayerType[PlayerType["LILITH"] = 13] = "LILITH";
    PlayerType[PlayerType["KEEPER"] = 14] = "KEEPER";
    PlayerType[PlayerType["APOLLYON"] = 15] = "APOLLYON";
    PlayerType[PlayerType["FORGOTTEN"] = 16] = "FORGOTTEN";
    PlayerType[PlayerType["SOUL"] = 17] = "SOUL";
    PlayerType[PlayerType["BETHANY"] = 18] = "BETHANY";
    PlayerType[PlayerType["JACOB"] = 19] = "JACOB";
    PlayerType[PlayerType["ESAU"] = 20] = "ESAU";
    /** Tainted Isaac */
    PlayerType[PlayerType["ISAAC_B"] = 21] = "ISAAC_B";
    /** Tainted Magdalene */
    PlayerType[PlayerType["MAGDALENE_B"] = 22] = "MAGDALENE_B";
    /** Tainted Cain */
    PlayerType[PlayerType["CAIN_B"] = 23] = "CAIN_B";
    /** Tainted Judas */
    PlayerType[PlayerType["JUDAS_B"] = 24] = "JUDAS_B";
    /** Tainted Blue Baby */
    PlayerType[PlayerType["BLUE_BABY_B"] = 25] = "BLUE_BABY_B";
    /** Tainted Eve */
    PlayerType[PlayerType["EVE_B"] = 26] = "EVE_B";
    /** Tainted Samson */
    PlayerType[PlayerType["SAMSON_B"] = 27] = "SAMSON_B";
    /** Tainted Azazel */
    PlayerType[PlayerType["AZAZEL_B"] = 28] = "AZAZEL_B";
    /** Tainted Lazarus */
    PlayerType[PlayerType["LAZARUS_B"] = 29] = "LAZARUS_B";
    /** Tainted Eden */
    PlayerType[PlayerType["EDEN_B"] = 30] = "EDEN_B";
    /** Tainted Lost */
    PlayerType[PlayerType["LOST_B"] = 31] = "LOST_B";
    /** Tainted Lilith */
    PlayerType[PlayerType["LILITH_B"] = 32] = "LILITH_B";
    /** Tainted Keeper */
    PlayerType[PlayerType["KEEPER_B"] = 33] = "KEEPER_B";
    /** Tainted Apollyon */
    PlayerType[PlayerType["APOLLYON_B"] = 34] = "APOLLYON_B";
    /** Tainted Forgotten */
    PlayerType[PlayerType["FORGOTTEN_B"] = 35] = "FORGOTTEN_B";
    /** Tainted Bethany */
    PlayerType[PlayerType["BETHANY_B"] = 36] = "BETHANY_B";
    /** Tainted Jacob */
    PlayerType[PlayerType["JACOB_B"] = 37] = "JACOB_B";
    /** Dead Tainted Lazarus */
    PlayerType[PlayerType["LAZARUS_2_B"] = 38] = "LAZARUS_2_B";
    /** Tainted Jacob in "Lost" form. */
    PlayerType[PlayerType["JACOB_2_B"] = 39] = "JACOB_2_B";
    /** Tainted Soul */
    PlayerType[PlayerType["SOUL_B"] = 40] = "SOUL_B";
})(PlayerType || (exports.PlayerType = PlayerType = {}));
/** For `EntityType.PLAYER` (1), `PlayerVariant.COOP_BABY` (1). */
var BabySubType;
(function (BabySubType) {
    BabySubType[BabySubType["UNASSIGNED"] = -1] = "UNASSIGNED";
    BabySubType[BabySubType["SPIDER"] = 0] = "SPIDER";
    BabySubType[BabySubType["LOVE"] = 1] = "LOVE";
    BabySubType[BabySubType["BLOAT"] = 2] = "BLOAT";
    BabySubType[BabySubType["WATER"] = 3] = "WATER";
    BabySubType[BabySubType["PSY"] = 4] = "PSY";
    BabySubType[BabySubType["CURSED"] = 5] = "CURSED";
    BabySubType[BabySubType["TROLL"] = 6] = "TROLL";
    BabySubType[BabySubType["YBAB"] = 7] = "YBAB";
    BabySubType[BabySubType["COCKEYED"] = 8] = "COCKEYED";
    BabySubType[BabySubType["HOST"] = 9] = "HOST";
    BabySubType[BabySubType["LOST"] = 10] = "LOST";
    BabySubType[BabySubType["CUTE"] = 11] = "CUTE";
    BabySubType[BabySubType["CROW"] = 12] = "CROW";
    BabySubType[BabySubType["SHADOW"] = 13] = "SHADOW";
    BabySubType[BabySubType["GLASS"] = 14] = "GLASS";
    BabySubType[BabySubType["GOLD"] = 15] = "GOLD";
    BabySubType[BabySubType["CY"] = 16] = "CY";
    BabySubType[BabySubType["BEAN"] = 17] = "BEAN";
    BabySubType[BabySubType["MAG"] = 18] = "MAG";
    BabySubType[BabySubType["WRATH"] = 19] = "WRATH";
    BabySubType[BabySubType["WRAPPED"] = 20] = "WRAPPED";
    BabySubType[BabySubType["BEGOTTEN"] = 21] = "BEGOTTEN";
    BabySubType[BabySubType["DEAD"] = 22] = "DEAD";
    BabySubType[BabySubType["FIGHTING"] = 23] = "FIGHTING";
    BabySubType[BabySubType["ZERO"] = 24] = "ZERO";
    BabySubType[BabySubType["GLITCH"] = 25] = "GLITCH";
    BabySubType[BabySubType["MAGNET"] = 26] = "MAGNET";
    BabySubType[BabySubType["BLACK"] = 27] = "BLACK";
    BabySubType[BabySubType["RED"] = 28] = "RED";
    BabySubType[BabySubType["WHITE"] = 29] = "WHITE";
    BabySubType[BabySubType["BLUE"] = 30] = "BLUE";
    BabySubType[BabySubType["RAGE"] = 31] = "RAGE";
    BabySubType[BabySubType["CRY"] = 32] = "CRY";
    BabySubType[BabySubType["YELLOW"] = 33] = "YELLOW";
    BabySubType[BabySubType["LONG"] = 34] = "LONG";
    BabySubType[BabySubType["GREEN"] = 35] = "GREEN";
    BabySubType[BabySubType["LIL"] = 36] = "LIL";
    BabySubType[BabySubType["BIG"] = 37] = "BIG";
    BabySubType[BabySubType["BROWN"] = 38] = "BROWN";
    BabySubType[BabySubType["NOOSE"] = 39] = "NOOSE";
    BabySubType[BabySubType["HIVE"] = 40] = "HIVE";
    BabySubType[BabySubType["BUDDY"] = 41] = "BUDDY";
    BabySubType[BabySubType["COLORFUL"] = 42] = "COLORFUL";
    BabySubType[BabySubType["WHORE"] = 43] = "WHORE";
    BabySubType[BabySubType["CRACKED"] = 44] = "CRACKED";
    BabySubType[BabySubType["DRIPPING"] = 45] = "DRIPPING";
    BabySubType[BabySubType["BLINDING"] = 46] = "BLINDING";
    BabySubType[BabySubType["SUCKY"] = 47] = "SUCKY";
    BabySubType[BabySubType["DARK"] = 48] = "DARK";
    BabySubType[BabySubType["PICKY"] = 49] = "PICKY";
    BabySubType[BabySubType["REVENGE"] = 50] = "REVENGE";
    BabySubType[BabySubType["BELIAL"] = 51] = "BELIAL";
    BabySubType[BabySubType["SALE"] = 52] = "SALE";
    BabySubType[BabySubType["GOAT"] = 53] = "GOAT";
    BabySubType[BabySubType["SUPER_GREED"] = 54] = "SUPER_GREED";
    BabySubType[BabySubType["MORT"] = 55] = "MORT";
    BabySubType[BabySubType["APOLLYON"] = 56] = "APOLLYON";
    BabySubType[BabySubType["BONE"] = 57] = "BONE";
    BabySubType[BabySubType["BOUND"] = 58] = "BOUND";
    BabySubType[BabySubType["FOUND_SOUL"] = 59] = "FOUND_SOUL";
    BabySubType[BabySubType["LOST_WHITE"] = 60] = "LOST_WHITE";
    BabySubType[BabySubType["LOST_BLACK"] = 61] = "LOST_BLACK";
    BabySubType[BabySubType["LOST_BLUE"] = 62] = "LOST_BLUE";
    BabySubType[BabySubType["LOST_GREY"] = 63] = "LOST_GREY";
    BabySubType[BabySubType["WISP"] = 64] = "WISP";
    BabySubType[BabySubType["DOUBLE"] = 65] = "DOUBLE";
    BabySubType[BabySubType["GLOWING"] = 66] = "GLOWING";
    BabySubType[BabySubType["ILLUSION"] = 67] = "ILLUSION";
    BabySubType[BabySubType["HOPE"] = 68] = "HOPE";
    BabySubType[BabySubType["SOLOMON_A"] = 69] = "SOLOMON_A";
    BabySubType[BabySubType["SOLOMON_B"] = 70] = "SOLOMON_B";
    BabySubType[BabySubType["BASIC"] = 71] = "BASIC";
})(BabySubType || (exports.BabySubType = BabySubType = {}));
/** For `EntityType.FAMILIAR` (3), `FamiliarVariant.BLUE_FLY` (43). */
var BlueFlySubType;
(function (BlueFlySubType) {
    /** A standard fly, like what you get from using Guppy's Head. */
    BlueFlySubType[BlueFlySubType["BLUE_FLY"] = 0] = "BLUE_FLY";
    /** Red (explosive) */
    BlueFlySubType[BlueFlySubType["WRATH"] = 1] = "WRATH";
    /** Green (poison) */
    BlueFlySubType[BlueFlySubType["PESTILENCE"] = 2] = "PESTILENCE";
    /** Yellow (slowing) */
    BlueFlySubType[BlueFlySubType["FAMINE"] = 3] = "FAMINE";
    /** Black (double-damage) */
    BlueFlySubType[BlueFlySubType["DEATH"] = 4] = "DEATH";
    /** White */
    BlueFlySubType[BlueFlySubType["CONQUEST"] = 5] = "CONQUEST";
})(BlueFlySubType || (exports.BlueFlySubType = BlueFlySubType = {}));
/** For `EntityType.FAMILIAR` (3), `FamiliarVariant.DIP` (201). */
var DipFamiliarSubType;
(function (DipFamiliarSubType) {
    DipFamiliarSubType[DipFamiliarSubType["NORMAL"] = 0] = "NORMAL";
    DipFamiliarSubType[DipFamiliarSubType["RED"] = 1] = "RED";
    DipFamiliarSubType[DipFamiliarSubType["CORNY"] = 2] = "CORNY";
    DipFamiliarSubType[DipFamiliarSubType["GOLD"] = 3] = "GOLD";
    DipFamiliarSubType[DipFamiliarSubType["RAINBOW"] = 4] = "RAINBOW";
    DipFamiliarSubType[DipFamiliarSubType["BLACK"] = 5] = "BLACK";
    DipFamiliarSubType[DipFamiliarSubType["WHITE"] = 6] = "WHITE";
    DipFamiliarSubType[DipFamiliarSubType["STONE"] = 12] = "STONE";
    DipFamiliarSubType[DipFamiliarSubType["FLAMING"] = 13] = "FLAMING";
    DipFamiliarSubType[DipFamiliarSubType["STINKY"] = 14] = "STINKY";
    DipFamiliarSubType[DipFamiliarSubType["BROWNIE"] = 20] = "BROWNIE";
})(DipFamiliarSubType || (exports.DipFamiliarSubType = DipFamiliarSubType = {}));
/** For `EntityType.FAMILIAR` (3), `FamiliarVariant.BLOOD_BABY` (238). */
var BloodClotSubType;
(function (BloodClotSubType) {
    BloodClotSubType[BloodClotSubType["RED"] = 0] = "RED";
    BloodClotSubType[BloodClotSubType["SOUL"] = 1] = "SOUL";
    BloodClotSubType[BloodClotSubType["BLACK"] = 2] = "BLACK";
    BloodClotSubType[BloodClotSubType["ETERNAL"] = 3] = "ETERNAL";
    BloodClotSubType[BloodClotSubType["GOLD"] = 4] = "GOLD";
    BloodClotSubType[BloodClotSubType["BONE"] = 5] = "BONE";
    BloodClotSubType[BloodClotSubType["ROTTEN"] = 6] = "ROTTEN";
    /** Spawned by the Blood Clot trinket; cannot be turned into health by Sumptorium. */
    BloodClotSubType[BloodClotSubType["RED_NO_SUMPTORIUM"] = 7] = "RED_NO_SUMPTORIUM";
})(BloodClotSubType || (exports.BloodClotSubType = BloodClotSubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.NULL` (0). */
var PickupNullSubType;
(function (PickupNullSubType) {
    /** Has a chance to spawn any possible pickup, including collectibles. */
    PickupNullSubType[PickupNullSubType["ALL"] = 0] = "ALL";
    PickupNullSubType[PickupNullSubType["EXCLUDE_COLLECTIBLES_CHESTS"] = 1] = "EXCLUDE_COLLECTIBLES_CHESTS";
    PickupNullSubType[PickupNullSubType["EXCLUDE_COLLECTIBLES"] = 2] = "EXCLUDE_COLLECTIBLES";
    PickupNullSubType[PickupNullSubType["EXCLUDE_COLLECTIBLES_CHESTS_COINS"] = 3] = "EXCLUDE_COLLECTIBLES_CHESTS_COINS";
    PickupNullSubType[PickupNullSubType["EXCLUDE_COLLECTIBLES_TRINKETS_CHESTS"] = 4] = "EXCLUDE_COLLECTIBLES_TRINKETS_CHESTS";
})(PickupNullSubType || (exports.PickupNullSubType = PickupNullSubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.HEART` (10). */
var HeartSubType;
(function (HeartSubType) {
    /**
     * Spawning hearts with this sub-type will produce a random heart with the following
     * probabilities:
     *
     * - `HeartSubType.FULL` (1) - 39.98%
     * - `HeartSubType.HALF` (2) - 39.99%
     * - `HeartSubType.SOUL` (3) - 6.73%
     * - `HeartSubType.ETERNAL` (4) - 1.80%
     * - `HeartSubType.DOUBLE_PACK` (5) - 4.21%
     * - `HeartSubType.BLACK` (6) - 0.50%
     * - `HeartSubType.GOLDEN` (7) - 0.63%
     * - `HeartSubType.HALF_SOUL` (8) - 2.24%
     * - `HeartSubType.SCARED` (9) - 0.87%
     * - `HeartSubType.BLENDED` (10) - 0.87%
     * - `HeartSubType.BONE` (11) - 0.47%
     * - `HeartSubType.ROTTEN` (12) - 1.71%
     */
    HeartSubType[HeartSubType["NULL"] = 0] = "NULL";
    HeartSubType[HeartSubType["FULL"] = 1] = "FULL";
    HeartSubType[HeartSubType["HALF"] = 2] = "HALF";
    HeartSubType[HeartSubType["SOUL"] = 3] = "SOUL";
    HeartSubType[HeartSubType["ETERNAL"] = 4] = "ETERNAL";
    HeartSubType[HeartSubType["DOUBLE_PACK"] = 5] = "DOUBLE_PACK";
    HeartSubType[HeartSubType["BLACK"] = 6] = "BLACK";
    HeartSubType[HeartSubType["GOLDEN"] = 7] = "GOLDEN";
    HeartSubType[HeartSubType["HALF_SOUL"] = 8] = "HALF_SOUL";
    HeartSubType[HeartSubType["SCARED"] = 9] = "SCARED";
    HeartSubType[HeartSubType["BLENDED"] = 10] = "BLENDED";
    HeartSubType[HeartSubType["BONE"] = 11] = "BONE";
    HeartSubType[HeartSubType["ROTTEN"] = 12] = "ROTTEN";
})(HeartSubType || (exports.HeartSubType = HeartSubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.COIN` (20). */
var CoinSubType;
(function (CoinSubType) {
    /**
     * Spawning coins with this sub-type will produce a random coin with the following probabilities:
     *
     * - `CoinSubType.PENNY` (1) - 92.63%
     * - `CoinSubType.NICKEL` (2) - 4.68%
     * - `CoinSubType.DIME` (3) - 1.00%
     * - `CoinSubType.DOUBLE_PACK` (4) - 0.00% (never spawns)
     * - `CoinSubType.LUCKY_PENNY` (5) - 0.94%
     * - `CoinSubType.STICKY_NICKEL` (6) - 0.25%
     * - `CoinSubType.GOLDEN` (7) - 0.50%
     */
    CoinSubType[CoinSubType["NULL"] = 0] = "NULL";
    CoinSubType[CoinSubType["PENNY"] = 1] = "PENNY";
    CoinSubType[CoinSubType["NICKEL"] = 2] = "NICKEL";
    CoinSubType[CoinSubType["DIME"] = 3] = "DIME";
    CoinSubType[CoinSubType["DOUBLE_PACK"] = 4] = "DOUBLE_PACK";
    CoinSubType[CoinSubType["LUCKY_PENNY"] = 5] = "LUCKY_PENNY";
    CoinSubType[CoinSubType["STICKY_NICKEL"] = 6] = "STICKY_NICKEL";
    CoinSubType[CoinSubType["GOLDEN"] = 7] = "GOLDEN";
})(CoinSubType || (exports.CoinSubType = CoinSubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.KEY` (30). */
var KeySubType;
(function (KeySubType) {
    /**
     * Spawning keys with this sub-type will produce a random key with the following probabilities:
     *
     * - `KeySubType.NORMAL` (1) - 96.08%
     * - `KeySubType.GOLDEN` (2) - 1.97%
     * - `KeySubType.DOUBLE_PACK` (3) - 0.00% (never spawns)
     * - `KeySubType.CHARGED` (4) - 1.96%
     */
    KeySubType[KeySubType["NULL"] = 0] = "NULL";
    KeySubType[KeySubType["NORMAL"] = 1] = "NORMAL";
    KeySubType[KeySubType["GOLDEN"] = 2] = "GOLDEN";
    KeySubType[KeySubType["DOUBLE_PACK"] = 3] = "DOUBLE_PACK";
    KeySubType[KeySubType["CHARGED"] = 4] = "CHARGED";
})(KeySubType || (exports.KeySubType = KeySubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.BOMB` (40). */
var BombSubType;
(function (BombSubType) {
    /**
     * Spawning bombs with this sub-type will produce a random bomb with the following probabilities:
     *
     * - `BombSubType.NORMAL` (1) - 74.84%
     * - `BombSubType.DOUBLE_PACK` (2) - 12.47%
     * - `BombSubType.TROLL` (3) - 9.9%
     * - `BombSubType.GOLDEN` (4) - 0.89%
     * - `BombSubType.MEGA_TROLL` (5) - 1.78%
     * - `BombSubType.GOLDEN_TROLL` (6) - 0.12%
     * - `BombSubType.GIGA` (7) - 0.00% (never spawns)
     */
    BombSubType[BombSubType["NULL"] = 0] = "NULL";
    BombSubType[BombSubType["NORMAL"] = 1] = "NORMAL";
    BombSubType[BombSubType["DOUBLE_PACK"] = 2] = "DOUBLE_PACK";
    BombSubType[BombSubType["TROLL"] = 3] = "TROLL";
    BombSubType[BombSubType["GOLDEN"] = 4] = "GOLDEN";
    BombSubType[BombSubType["MEGA_TROLL"] = 5] = "MEGA_TROLL";
    BombSubType[BombSubType["GOLDEN_TROLL"] = 6] = "GOLDEN_TROLL";
    BombSubType[BombSubType["GIGA"] = 7] = "GIGA";
})(BombSubType || (exports.BombSubType = BombSubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.POOP` (42). */
var PoopPickupSubType;
(function (PoopPickupSubType) {
    /** Equal to "Poop Nugget" in "entities2.xml". */
    PoopPickupSubType[PoopPickupSubType["SMALL"] = 0] = "SMALL";
    /** Equal to "Big Poop Nugget" in "entities2.xml". */
    PoopPickupSubType[PoopPickupSubType["BIG"] = 1] = "BIG";
})(PoopPickupSubType || (exports.PoopPickupSubType = PoopPickupSubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.CHEST` (50). */
var ChestSubType;
(function (ChestSubType) {
    ChestSubType[ChestSubType["OPENED"] = 0] = "OPENED";
    ChestSubType[ChestSubType["CLOSED"] = 1] = "CLOSED";
})(ChestSubType || (exports.ChestSubType = ChestSubType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.SACK` (69). */
var SackSubType;
(function (SackSubType) {
    /**
     * Spawning sacks with this sub-type will produce a random sack with the following probabilities:
     *
     * - `SackSubType.NORMAL` (1) - 99.0%
     * - `SackSubType.BLACK` (2) - 1.0%
     */
    SackSubType[SackSubType["NULL"] = 0] = "NULL";
    SackSubType[SackSubType["NORMAL"] = 1] = "NORMAL";
    SackSubType[SackSubType["BLACK"] = 2] = "BLACK";
})(SackSubType || (exports.SackSubType = SackSubType = {}));
/**
 * For `EntityType.PICKUP` (5), `PickupVariant.PILL` (70).
 *
 * This is the sub-type of a pill.
 */
var PillColor;
(function (PillColor) {
    /**
     * Spawning pills with this sub-type will produce a random pill with the following probabilities:
     *
     * - Random normal pill - 97.86%
     * - Specific normal pill - 7.53%
     * - Gold pill - 0.7%
     * - Random horse pill - 1.43%
     * - Specific horse pill - 0.11%
     * - Horse gold pill - 0.01%
     */
    PillColor[PillColor["NULL"] = 0] = "NULL";
    PillColor[PillColor["BLUE_BLUE"] = 1] = "BLUE_BLUE";
    PillColor[PillColor["WHITE_BLUE"] = 2] = "WHITE_BLUE";
    PillColor[PillColor["ORANGE_ORANGE"] = 3] = "ORANGE_ORANGE";
    PillColor[PillColor["WHITE_WHITE"] = 4] = "WHITE_WHITE";
    PillColor[PillColor["RED_DOTS_RED"] = 5] = "RED_DOTS_RED";
    PillColor[PillColor["PINK_RED"] = 6] = "PINK_RED";
    PillColor[PillColor["BLUE_CADET_BLUE"] = 7] = "BLUE_CADET_BLUE";
    PillColor[PillColor["YELLOW_ORANGE"] = 8] = "YELLOW_ORANGE";
    PillColor[PillColor["ORANGE_DOTS_WHITE"] = 9] = "ORANGE_DOTS_WHITE";
    PillColor[PillColor["WHITE_AZURE"] = 10] = "WHITE_AZURE";
    PillColor[PillColor["BLACK_YELLOW"] = 11] = "BLACK_YELLOW";
    PillColor[PillColor["WHITE_BLACK"] = 12] = "WHITE_BLACK";
    PillColor[PillColor["WHITE_YELLOW"] = 13] = "WHITE_YELLOW";
    PillColor[PillColor["GOLD"] = 14] = "GOLD";
    PillColor[PillColor["HORSE_BLUE_BLUE"] = 2049] = "HORSE_BLUE_BLUE";
    PillColor[PillColor["HORSE_WHITE_BLUE"] = 2050] = "HORSE_WHITE_BLUE";
    PillColor[PillColor["HORSE_ORANGE_ORANGE"] = 2051] = "HORSE_ORANGE_ORANGE";
    PillColor[PillColor["HORSE_WHITE_WHITE"] = 2052] = "HORSE_WHITE_WHITE";
    PillColor[PillColor["HORSE_RED_DOTS_RED"] = 2053] = "HORSE_RED_DOTS_RED";
    PillColor[PillColor["HORSE_PINK_RED"] = 2054] = "HORSE_PINK_RED";
    PillColor[PillColor["HORSE_BLUE_CADET_BLUE"] = 2055] = "HORSE_BLUE_CADET_BLUE";
    PillColor[PillColor["HORSE_YELLOW_ORANGE"] = 2056] = "HORSE_YELLOW_ORANGE";
    PillColor[PillColor["HORSE_ORANGE_DOTS_WHITE"] = 2057] = "HORSE_ORANGE_DOTS_WHITE";
    PillColor[PillColor["HORSE_WHITE_AZURE"] = 2058] = "HORSE_WHITE_AZURE";
    PillColor[PillColor["HORSE_BLACK_YELLOW"] = 2059] = "HORSE_BLACK_YELLOW";
    PillColor[PillColor["HORSE_WHITE_BLACK"] = 2060] = "HORSE_WHITE_BLACK";
    PillColor[PillColor["HORSE_WHITE_YELLOW"] = 2061] = "HORSE_WHITE_YELLOW";
    PillColor[PillColor["HORSE_GOLD"] = 2062] = "HORSE_GOLD";
})(PillColor || (exports.PillColor = PillColor = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.LIL_BATTERY` (90). */
var BatterySubType;
(function (BatterySubType) {
    /**
     * Spawning batteries with this sub-type will produce a random battery with the following
     * probabilities:
     *
     * - `BatterySubType.NORMAL` (1) - 32.72%
     * - `BatterySubType.MICRO` (2) - 65.44%
     * - `BatterySubType.MEGA` (3) - 1.00%
     * - `BatterySubType.GOLDEN` (4) - 0.83%
     */
    BatterySubType[BatterySubType["NULL"] = 0] = "NULL";
    BatterySubType[BatterySubType["NORMAL"] = 1] = "NORMAL";
    BatterySubType[BatterySubType["MICRO"] = 2] = "MICRO";
    BatterySubType[BatterySubType["MEGA"] = 3] = "MEGA";
    BatterySubType[BatterySubType["GOLDEN"] = 4] = "GOLDEN";
})(BatterySubType || (exports.BatterySubType = BatterySubType = {}));
/**
 * For `EntityType.PICKUP` (5), `PickupVariant.COLLECTIBLE` (100).
 *
 * This is the sub-type of a collectible.
 *
 * This enum is not contiguous. In other words, the enum ranges from `CollectibleType.NULL` (0) to
 * `CollectibleType.MOMS_RING` (732), but there is no corresponding `CollectibleType` with the
 * following values:
 *
 * 1. 43 (Pills here)
 * 2. 61 (Tarot Card)
 * 3. 235
 * 4. 587 (Menorah)
 * 5. 613 (Salt Shaker)
 * 6. 620 (Voodoo Pin)
 * 7. 630 (Lucky Seven)
 * 8. 648 (Pill Crusher)
 * 9. 662
 * 10. 666
 * 11. 718
 */
var CollectibleType;
(function (CollectibleType) {
    /** Spawning collectibles with this sub-type will produce a random collectible. */
    CollectibleType[CollectibleType["NULL"] = 0] = "NULL";
    CollectibleType[CollectibleType["SAD_ONION"] = 1] = "SAD_ONION";
    CollectibleType[CollectibleType["INNER_EYE"] = 2] = "INNER_EYE";
    CollectibleType[CollectibleType["SPOON_BENDER"] = 3] = "SPOON_BENDER";
    CollectibleType[CollectibleType["CRICKETS_HEAD"] = 4] = "CRICKETS_HEAD";
    CollectibleType[CollectibleType["MY_REFLECTION"] = 5] = "MY_REFLECTION";
    CollectibleType[CollectibleType["NUMBER_ONE"] = 6] = "NUMBER_ONE";
    CollectibleType[CollectibleType["BLOOD_OF_THE_MARTYR"] = 7] = "BLOOD_OF_THE_MARTYR";
    CollectibleType[CollectibleType["BROTHER_BOBBY"] = 8] = "BROTHER_BOBBY";
    CollectibleType[CollectibleType["SKATOLE"] = 9] = "SKATOLE";
    CollectibleType[CollectibleType["HALO_OF_FLIES"] = 10] = "HALO_OF_FLIES";
    CollectibleType[CollectibleType["ONE_UP"] = 11] = "ONE_UP";
    CollectibleType[CollectibleType["MAGIC_MUSHROOM"] = 12] = "MAGIC_MUSHROOM";
    CollectibleType[CollectibleType["VIRUS"] = 13] = "VIRUS";
    CollectibleType[CollectibleType["ROID_RAGE"] = 14] = "ROID_RAGE";
    /** <3 */
    CollectibleType[CollectibleType["HEART"] = 15] = "HEART";
    CollectibleType[CollectibleType["RAW_LIVER"] = 16] = "RAW_LIVER";
    CollectibleType[CollectibleType["SKELETON_KEY"] = 17] = "SKELETON_KEY";
    CollectibleType[CollectibleType["DOLLAR"] = 18] = "DOLLAR";
    CollectibleType[CollectibleType["BOOM"] = 19] = "BOOM";
    CollectibleType[CollectibleType["TRANSCENDENCE"] = 20] = "TRANSCENDENCE";
    CollectibleType[CollectibleType["COMPASS"] = 21] = "COMPASS";
    CollectibleType[CollectibleType["LUNCH"] = 22] = "LUNCH";
    CollectibleType[CollectibleType["DINNER"] = 23] = "DINNER";
    CollectibleType[CollectibleType["DESSERT"] = 24] = "DESSERT";
    CollectibleType[CollectibleType["BREAKFAST"] = 25] = "BREAKFAST";
    CollectibleType[CollectibleType["ROTTEN_MEAT"] = 26] = "ROTTEN_MEAT";
    CollectibleType[CollectibleType["WOODEN_SPOON"] = 27] = "WOODEN_SPOON";
    CollectibleType[CollectibleType["BELT"] = 28] = "BELT";
    CollectibleType[CollectibleType["MOMS_UNDERWEAR"] = 29] = "MOMS_UNDERWEAR";
    CollectibleType[CollectibleType["MOMS_HEELS"] = 30] = "MOMS_HEELS";
    CollectibleType[CollectibleType["MOMS_LIPSTICK"] = 31] = "MOMS_LIPSTICK";
    CollectibleType[CollectibleType["WIRE_COAT_HANGER"] = 32] = "WIRE_COAT_HANGER";
    CollectibleType[CollectibleType["BIBLE"] = 33] = "BIBLE";
    CollectibleType[CollectibleType["BOOK_OF_BELIAL"] = 34] = "BOOK_OF_BELIAL";
    CollectibleType[CollectibleType["NECRONOMICON"] = 35] = "NECRONOMICON";
    CollectibleType[CollectibleType["POOP"] = 36] = "POOP";
    CollectibleType[CollectibleType["MR_BOOM"] = 37] = "MR_BOOM";
    CollectibleType[CollectibleType["TAMMYS_HEAD"] = 38] = "TAMMYS_HEAD";
    CollectibleType[CollectibleType["MOMS_BRA"] = 39] = "MOMS_BRA";
    CollectibleType[CollectibleType["KAMIKAZE"] = 40] = "KAMIKAZE";
    CollectibleType[CollectibleType["MOMS_PAD"] = 41] = "MOMS_PAD";
    CollectibleType[CollectibleType["BOBS_ROTTEN_HEAD"] = 42] = "BOBS_ROTTEN_HEAD";
    // - There is no enum member with a value of 43. (This has a placeholder name of "Pills here" in
    //   the "items.xml" file.)
    CollectibleType[CollectibleType["TELEPORT"] = 44] = "TELEPORT";
    CollectibleType[CollectibleType["YUM_HEART"] = 45] = "YUM_HEART";
    CollectibleType[CollectibleType["LUCKY_FOOT"] = 46] = "LUCKY_FOOT";
    CollectibleType[CollectibleType["DOCTORS_REMOTE"] = 47] = "DOCTORS_REMOTE";
    CollectibleType[CollectibleType["CUPIDS_ARROW"] = 48] = "CUPIDS_ARROW";
    CollectibleType[CollectibleType["SHOOP_DA_WHOOP"] = 49] = "SHOOP_DA_WHOOP";
    CollectibleType[CollectibleType["STEVEN"] = 50] = "STEVEN";
    CollectibleType[CollectibleType["PENTAGRAM"] = 51] = "PENTAGRAM";
    CollectibleType[CollectibleType["DR_FETUS"] = 52] = "DR_FETUS";
    CollectibleType[CollectibleType["MAGNETO"] = 53] = "MAGNETO";
    CollectibleType[CollectibleType["TREASURE_MAP"] = 54] = "TREASURE_MAP";
    CollectibleType[CollectibleType["MOMS_EYE"] = 55] = "MOMS_EYE";
    CollectibleType[CollectibleType["LEMON_MISHAP"] = 56] = "LEMON_MISHAP";
    CollectibleType[CollectibleType["DISTANT_ADMIRATION"] = 57] = "DISTANT_ADMIRATION";
    CollectibleType[CollectibleType["BOOK_OF_SHADOWS"] = 58] = "BOOK_OF_SHADOWS";
    /**
     * This is the collectible that Judas is granted when he picks up Birthright. It acts in a similar
     * way to Book of Virtues.
     */
    CollectibleType[CollectibleType["BOOK_OF_BELIAL_BIRTHRIGHT"] = 59] = "BOOK_OF_BELIAL_BIRTHRIGHT";
    CollectibleType[CollectibleType["LADDER"] = 60] = "LADDER";
    // - There is no enum member with a value of 61. (This has a placeholder name of "Tarot Card" in
    //   the "items.xml" file.)
    CollectibleType[CollectibleType["CHARM_OF_THE_VAMPIRE"] = 62] = "CHARM_OF_THE_VAMPIRE";
    CollectibleType[CollectibleType["BATTERY"] = 63] = "BATTERY";
    CollectibleType[CollectibleType["STEAM_SALE"] = 64] = "STEAM_SALE";
    CollectibleType[CollectibleType["ANARCHIST_COOKBOOK"] = 65] = "ANARCHIST_COOKBOOK";
    CollectibleType[CollectibleType["HOURGLASS"] = 66] = "HOURGLASS";
    CollectibleType[CollectibleType["SISTER_MAGGY"] = 67] = "SISTER_MAGGY";
    CollectibleType[CollectibleType["TECHNOLOGY"] = 68] = "TECHNOLOGY";
    CollectibleType[CollectibleType["CHOCOLATE_MILK"] = 69] = "CHOCOLATE_MILK";
    CollectibleType[CollectibleType["GROWTH_HORMONES"] = 70] = "GROWTH_HORMONES";
    CollectibleType[CollectibleType["MINI_MUSH"] = 71] = "MINI_MUSH";
    CollectibleType[CollectibleType["ROSARY"] = 72] = "ROSARY";
    CollectibleType[CollectibleType["CUBE_OF_MEAT"] = 73] = "CUBE_OF_MEAT";
    CollectibleType[CollectibleType["QUARTER"] = 74] = "QUARTER";
    CollectibleType[CollectibleType["PHD"] = 75] = "PHD";
    CollectibleType[CollectibleType["XRAY_VISION"] = 76] = "XRAY_VISION";
    CollectibleType[CollectibleType["MY_LITTLE_UNICORN"] = 77] = "MY_LITTLE_UNICORN";
    CollectibleType[CollectibleType["BOOK_OF_REVELATIONS"] = 78] = "BOOK_OF_REVELATIONS";
    CollectibleType[CollectibleType["MARK"] = 79] = "MARK";
    CollectibleType[CollectibleType["PACT"] = 80] = "PACT";
    CollectibleType[CollectibleType["DEAD_CAT"] = 81] = "DEAD_CAT";
    CollectibleType[CollectibleType["LORD_OF_THE_PIT"] = 82] = "LORD_OF_THE_PIT";
    CollectibleType[CollectibleType["NAIL"] = 83] = "NAIL";
    CollectibleType[CollectibleType["WE_NEED_TO_GO_DEEPER"] = 84] = "WE_NEED_TO_GO_DEEPER";
    CollectibleType[CollectibleType["DECK_OF_CARDS"] = 85] = "DECK_OF_CARDS";
    CollectibleType[CollectibleType["MONSTROS_TOOTH"] = 86] = "MONSTROS_TOOTH";
    CollectibleType[CollectibleType["LOKIS_HORNS"] = 87] = "LOKIS_HORNS";
    CollectibleType[CollectibleType["LITTLE_CHUBBY"] = 88] = "LITTLE_CHUBBY";
    CollectibleType[CollectibleType["SPIDER_BITE"] = 89] = "SPIDER_BITE";
    CollectibleType[CollectibleType["SMALL_ROCK"] = 90] = "SMALL_ROCK";
    CollectibleType[CollectibleType["SPELUNKER_HAT"] = 91] = "SPELUNKER_HAT";
    CollectibleType[CollectibleType["SUPER_BANDAGE"] = 92] = "SUPER_BANDAGE";
    CollectibleType[CollectibleType["GAMEKID"] = 93] = "GAMEKID";
    CollectibleType[CollectibleType["SACK_OF_PENNIES"] = 94] = "SACK_OF_PENNIES";
    CollectibleType[CollectibleType["ROBO_BABY"] = 95] = "ROBO_BABY";
    CollectibleType[CollectibleType["LITTLE_CHAD"] = 96] = "LITTLE_CHAD";
    CollectibleType[CollectibleType["BOOK_OF_SIN"] = 97] = "BOOK_OF_SIN";
    CollectibleType[CollectibleType["RELIC"] = 98] = "RELIC";
    CollectibleType[CollectibleType["LITTLE_GISH"] = 99] = "LITTLE_GISH";
    CollectibleType[CollectibleType["LITTLE_STEVEN"] = 100] = "LITTLE_STEVEN";
    CollectibleType[CollectibleType["HALO"] = 101] = "HALO";
    CollectibleType[CollectibleType["MOMS_BOTTLE_OF_PILLS"] = 102] = "MOMS_BOTTLE_OF_PILLS";
    CollectibleType[CollectibleType["COMMON_COLD"] = 103] = "COMMON_COLD";
    CollectibleType[CollectibleType["PARASITE"] = 104] = "PARASITE";
    CollectibleType[CollectibleType["D6"] = 105] = "D6";
    CollectibleType[CollectibleType["MR_MEGA"] = 106] = "MR_MEGA";
    CollectibleType[CollectibleType["PINKING_SHEARS"] = 107] = "PINKING_SHEARS";
    CollectibleType[CollectibleType["WAFER"] = 108] = "WAFER";
    CollectibleType[CollectibleType["MONEY_EQUALS_POWER"] = 109] = "MONEY_EQUALS_POWER";
    CollectibleType[CollectibleType["MOMS_CONTACTS"] = 110] = "MOMS_CONTACTS";
    CollectibleType[CollectibleType["BEAN"] = 111] = "BEAN";
    CollectibleType[CollectibleType["GUARDIAN_ANGEL"] = 112] = "GUARDIAN_ANGEL";
    CollectibleType[CollectibleType["DEMON_BABY"] = 113] = "DEMON_BABY";
    CollectibleType[CollectibleType["MOMS_KNIFE"] = 114] = "MOMS_KNIFE";
    CollectibleType[CollectibleType["OUIJA_BOARD"] = 115] = "OUIJA_BOARD";
    CollectibleType[CollectibleType["NINE_VOLT"] = 116] = "NINE_VOLT";
    CollectibleType[CollectibleType["DEAD_BIRD"] = 117] = "DEAD_BIRD";
    CollectibleType[CollectibleType["BRIMSTONE"] = 118] = "BRIMSTONE";
    CollectibleType[CollectibleType["BLOOD_BAG"] = 119] = "BLOOD_BAG";
    CollectibleType[CollectibleType["ODD_MUSHROOM_THIN"] = 120] = "ODD_MUSHROOM_THIN";
    CollectibleType[CollectibleType["ODD_MUSHROOM_LARGE"] = 121] = "ODD_MUSHROOM_LARGE";
    CollectibleType[CollectibleType["WHORE_OF_BABYLON"] = 122] = "WHORE_OF_BABYLON";
    CollectibleType[CollectibleType["MONSTER_MANUAL"] = 123] = "MONSTER_MANUAL";
    CollectibleType[CollectibleType["DEAD_SEA_SCROLLS"] = 124] = "DEAD_SEA_SCROLLS";
    CollectibleType[CollectibleType["BOBBY_BOMB"] = 125] = "BOBBY_BOMB";
    CollectibleType[CollectibleType["RAZOR_BLADE"] = 126] = "RAZOR_BLADE";
    CollectibleType[CollectibleType["FORGET_ME_NOW"] = 127] = "FORGET_ME_NOW";
    CollectibleType[CollectibleType["FOREVER_ALONE"] = 128] = "FOREVER_ALONE";
    CollectibleType[CollectibleType["BUCKET_OF_LARD"] = 129] = "BUCKET_OF_LARD";
    CollectibleType[CollectibleType["PONY"] = 130] = "PONY";
    CollectibleType[CollectibleType["BOMB_BAG"] = 131] = "BOMB_BAG";
    CollectibleType[CollectibleType["LUMP_OF_COAL"] = 132] = "LUMP_OF_COAL";
    CollectibleType[CollectibleType["GUPPYS_PAW"] = 133] = "GUPPYS_PAW";
    CollectibleType[CollectibleType["GUPPYS_TAIL"] = 134] = "GUPPYS_TAIL";
    CollectibleType[CollectibleType["IV_BAG"] = 135] = "IV_BAG";
    CollectibleType[CollectibleType["BEST_FRIEND"] = 136] = "BEST_FRIEND";
    CollectibleType[CollectibleType["REMOTE_DETONATOR"] = 137] = "REMOTE_DETONATOR";
    CollectibleType[CollectibleType["STIGMATA"] = 138] = "STIGMATA";
    CollectibleType[CollectibleType["MOMS_PURSE"] = 139] = "MOMS_PURSE";
    CollectibleType[CollectibleType["BOBS_CURSE"] = 140] = "BOBS_CURSE";
    CollectibleType[CollectibleType["PAGEANT_BOY"] = 141] = "PAGEANT_BOY";
    CollectibleType[CollectibleType["SCAPULAR"] = 142] = "SCAPULAR";
    CollectibleType[CollectibleType["SPEED_BALL"] = 143] = "SPEED_BALL";
    CollectibleType[CollectibleType["BUM_FRIEND"] = 144] = "BUM_FRIEND";
    CollectibleType[CollectibleType["GUPPYS_HEAD"] = 145] = "GUPPYS_HEAD";
    CollectibleType[CollectibleType["PRAYER_CARD"] = 146] = "PRAYER_CARD";
    CollectibleType[CollectibleType["NOTCHED_AXE"] = 147] = "NOTCHED_AXE";
    CollectibleType[CollectibleType["INFESTATION"] = 148] = "INFESTATION";
    CollectibleType[CollectibleType["IPECAC"] = 149] = "IPECAC";
    CollectibleType[CollectibleType["TOUGH_LOVE"] = 150] = "TOUGH_LOVE";
    CollectibleType[CollectibleType["MULLIGAN"] = 151] = "MULLIGAN";
    CollectibleType[CollectibleType["TECHNOLOGY_2"] = 152] = "TECHNOLOGY_2";
    CollectibleType[CollectibleType["MUTANT_SPIDER"] = 153] = "MUTANT_SPIDER";
    CollectibleType[CollectibleType["CHEMICAL_PEEL"] = 154] = "CHEMICAL_PEEL";
    CollectibleType[CollectibleType["PEEPER"] = 155] = "PEEPER";
    CollectibleType[CollectibleType["HABIT"] = 156] = "HABIT";
    CollectibleType[CollectibleType["BLOODY_LUST"] = 157] = "BLOODY_LUST";
    CollectibleType[CollectibleType["CRYSTAL_BALL"] = 158] = "CRYSTAL_BALL";
    CollectibleType[CollectibleType["SPIRIT_OF_THE_NIGHT"] = 159] = "SPIRIT_OF_THE_NIGHT";
    CollectibleType[CollectibleType["CRACK_THE_SKY"] = 160] = "CRACK_THE_SKY";
    CollectibleType[CollectibleType["ANKH"] = 161] = "ANKH";
    CollectibleType[CollectibleType["CELTIC_CROSS"] = 162] = "CELTIC_CROSS";
    CollectibleType[CollectibleType["GHOST_BABY"] = 163] = "GHOST_BABY";
    CollectibleType[CollectibleType["CANDLE"] = 164] = "CANDLE";
    CollectibleType[CollectibleType["CAT_O_NINE_TAILS"] = 165] = "CAT_O_NINE_TAILS";
    CollectibleType[CollectibleType["D20"] = 166] = "D20";
    CollectibleType[CollectibleType["HARLEQUIN_BABY"] = 167] = "HARLEQUIN_BABY";
    CollectibleType[CollectibleType["EPIC_FETUS"] = 168] = "EPIC_FETUS";
    CollectibleType[CollectibleType["POLYPHEMUS"] = 169] = "POLYPHEMUS";
    CollectibleType[CollectibleType["DADDY_LONGLEGS"] = 170] = "DADDY_LONGLEGS";
    CollectibleType[CollectibleType["SPIDER_BUTT"] = 171] = "SPIDER_BUTT";
    CollectibleType[CollectibleType["SACRIFICIAL_DAGGER"] = 172] = "SACRIFICIAL_DAGGER";
    CollectibleType[CollectibleType["MITRE"] = 173] = "MITRE";
    CollectibleType[CollectibleType["RAINBOW_BABY"] = 174] = "RAINBOW_BABY";
    CollectibleType[CollectibleType["DADS_KEY"] = 175] = "DADS_KEY";
    CollectibleType[CollectibleType["STEM_CELLS"] = 176] = "STEM_CELLS";
    CollectibleType[CollectibleType["PORTABLE_SLOT"] = 177] = "PORTABLE_SLOT";
    CollectibleType[CollectibleType["HOLY_WATER"] = 178] = "HOLY_WATER";
    CollectibleType[CollectibleType["FATE"] = 179] = "FATE";
    CollectibleType[CollectibleType["BLACK_BEAN"] = 180] = "BLACK_BEAN";
    CollectibleType[CollectibleType["WHITE_PONY"] = 181] = "WHITE_PONY";
    CollectibleType[CollectibleType["SACRED_HEART"] = 182] = "SACRED_HEART";
    CollectibleType[CollectibleType["TOOTH_PICKS"] = 183] = "TOOTH_PICKS";
    CollectibleType[CollectibleType["HOLY_GRAIL"] = 184] = "HOLY_GRAIL";
    CollectibleType[CollectibleType["DEAD_DOVE"] = 185] = "DEAD_DOVE";
    CollectibleType[CollectibleType["BLOOD_RIGHTS"] = 186] = "BLOOD_RIGHTS";
    CollectibleType[CollectibleType["GUPPYS_HAIRBALL"] = 187] = "GUPPYS_HAIRBALL";
    CollectibleType[CollectibleType["ABEL"] = 188] = "ABEL";
    CollectibleType[CollectibleType["SMB_SUPER_FAN"] = 189] = "SMB_SUPER_FAN";
    CollectibleType[CollectibleType["PYRO"] = 190] = "PYRO";
    CollectibleType[CollectibleType["THREE_DOLLAR_BILL"] = 191] = "THREE_DOLLAR_BILL";
    CollectibleType[CollectibleType["TELEPATHY_BOOK"] = 192] = "TELEPATHY_BOOK";
    CollectibleType[CollectibleType["MEAT"] = 193] = "MEAT";
    CollectibleType[CollectibleType["MAGIC_8_BALL"] = 194] = "MAGIC_8_BALL";
    CollectibleType[CollectibleType["MOMS_COIN_PURSE"] = 195] = "MOMS_COIN_PURSE";
    CollectibleType[CollectibleType["SQUEEZY"] = 196] = "SQUEEZY";
    CollectibleType[CollectibleType["JESUS_JUICE"] = 197] = "JESUS_JUICE";
    CollectibleType[CollectibleType["BOX"] = 198] = "BOX";
    CollectibleType[CollectibleType["MOMS_KEY"] = 199] = "MOMS_KEY";
    CollectibleType[CollectibleType["MOMS_EYESHADOW"] = 200] = "MOMS_EYESHADOW";
    CollectibleType[CollectibleType["IRON_BAR"] = 201] = "IRON_BAR";
    CollectibleType[CollectibleType["MIDAS_TOUCH"] = 202] = "MIDAS_TOUCH";
    CollectibleType[CollectibleType["HUMBLING_BUNDLE"] = 203] = "HUMBLING_BUNDLE";
    CollectibleType[CollectibleType["FANNY_PACK"] = 204] = "FANNY_PACK";
    CollectibleType[CollectibleType["SHARP_PLUG"] = 205] = "SHARP_PLUG";
    CollectibleType[CollectibleType["GUILLOTINE"] = 206] = "GUILLOTINE";
    CollectibleType[CollectibleType["BALL_OF_BANDAGES"] = 207] = "BALL_OF_BANDAGES";
    CollectibleType[CollectibleType["CHAMPION_BELT"] = 208] = "CHAMPION_BELT";
    CollectibleType[CollectibleType["BUTT_BOMBS"] = 209] = "BUTT_BOMBS";
    CollectibleType[CollectibleType["GNAWED_LEAF"] = 210] = "GNAWED_LEAF";
    CollectibleType[CollectibleType["SPIDERBABY"] = 211] = "SPIDERBABY";
    CollectibleType[CollectibleType["GUPPYS_COLLAR"] = 212] = "GUPPYS_COLLAR";
    CollectibleType[CollectibleType["LOST_CONTACT"] = 213] = "LOST_CONTACT";
    CollectibleType[CollectibleType["ANEMIC"] = 214] = "ANEMIC";
    CollectibleType[CollectibleType["GOAT_HEAD"] = 215] = "GOAT_HEAD";
    CollectibleType[CollectibleType["CEREMONIAL_ROBES"] = 216] = "CEREMONIAL_ROBES";
    CollectibleType[CollectibleType["MOMS_WIG"] = 217] = "MOMS_WIG";
    CollectibleType[CollectibleType["PLACENTA"] = 218] = "PLACENTA";
    CollectibleType[CollectibleType["OLD_BANDAGE"] = 219] = "OLD_BANDAGE";
    CollectibleType[CollectibleType["SAD_BOMBS"] = 220] = "SAD_BOMBS";
    CollectibleType[CollectibleType["RUBBER_CEMENT"] = 221] = "RUBBER_CEMENT";
    CollectibleType[CollectibleType["ANTI_GRAVITY"] = 222] = "ANTI_GRAVITY";
    CollectibleType[CollectibleType["PYROMANIAC"] = 223] = "PYROMANIAC";
    CollectibleType[CollectibleType["CRICKETS_BODY"] = 224] = "CRICKETS_BODY";
    CollectibleType[CollectibleType["GIMPY"] = 225] = "GIMPY";
    CollectibleType[CollectibleType["BLACK_LOTUS"] = 226] = "BLACK_LOTUS";
    CollectibleType[CollectibleType["PIGGY_BANK"] = 227] = "PIGGY_BANK";
    CollectibleType[CollectibleType["MOMS_PERFUME"] = 228] = "MOMS_PERFUME";
    CollectibleType[CollectibleType["MONSTROS_LUNG"] = 229] = "MONSTROS_LUNG";
    CollectibleType[CollectibleType["ABADDON"] = 230] = "ABADDON";
    CollectibleType[CollectibleType["BALL_OF_TAR"] = 231] = "BALL_OF_TAR";
    CollectibleType[CollectibleType["STOP_WATCH"] = 232] = "STOP_WATCH";
    CollectibleType[CollectibleType["TINY_PLANET"] = 233] = "TINY_PLANET";
    CollectibleType[CollectibleType["INFESTATION_2"] = 234] = "INFESTATION_2";
    // - There is no enum member with a value of 235.
    CollectibleType[CollectibleType["E_COLI"] = 236] = "E_COLI";
    CollectibleType[CollectibleType["DEATHS_TOUCH"] = 237] = "DEATHS_TOUCH";
    CollectibleType[CollectibleType["KEY_PIECE_1"] = 238] = "KEY_PIECE_1";
    CollectibleType[CollectibleType["KEY_PIECE_2"] = 239] = "KEY_PIECE_2";
    CollectibleType[CollectibleType["EXPERIMENTAL_TREATMENT"] = 240] = "EXPERIMENTAL_TREATMENT";
    CollectibleType[CollectibleType["CONTRACT_FROM_BELOW"] = 241] = "CONTRACT_FROM_BELOW";
    CollectibleType[CollectibleType["INFAMY"] = 242] = "INFAMY";
    CollectibleType[CollectibleType["TRINITY_SHIELD"] = 243] = "TRINITY_SHIELD";
    CollectibleType[CollectibleType["TECH_5"] = 244] = "TECH_5";
    CollectibleType[CollectibleType["TWENTY_TWENTY"] = 245] = "TWENTY_TWENTY";
    CollectibleType[CollectibleType["BLUE_MAP"] = 246] = "BLUE_MAP";
    CollectibleType[CollectibleType["BFFS"] = 247] = "BFFS";
    CollectibleType[CollectibleType["HIVE_MIND"] = 248] = "HIVE_MIND";
    CollectibleType[CollectibleType["THERES_OPTIONS"] = 249] = "THERES_OPTIONS";
    CollectibleType[CollectibleType["BOGO_BOMBS"] = 250] = "BOGO_BOMBS";
    CollectibleType[CollectibleType["STARTER_DECK"] = 251] = "STARTER_DECK";
    CollectibleType[CollectibleType["LITTLE_BAGGY"] = 252] = "LITTLE_BAGGY";
    CollectibleType[CollectibleType["MAGIC_SCAB"] = 253] = "MAGIC_SCAB";
    CollectibleType[CollectibleType["BLOOD_CLOT"] = 254] = "BLOOD_CLOT";
    CollectibleType[CollectibleType["SCREW"] = 255] = "SCREW";
    CollectibleType[CollectibleType["HOT_BOMBS"] = 256] = "HOT_BOMBS";
    CollectibleType[CollectibleType["FIRE_MIND"] = 257] = "FIRE_MIND";
    CollectibleType[CollectibleType["MISSING_NO"] = 258] = "MISSING_NO";
    CollectibleType[CollectibleType["DARK_MATTER"] = 259] = "DARK_MATTER";
    CollectibleType[CollectibleType["BLACK_CANDLE"] = 260] = "BLACK_CANDLE";
    CollectibleType[CollectibleType["PROPTOSIS"] = 261] = "PROPTOSIS";
    CollectibleType[CollectibleType["MISSING_PAGE_2"] = 262] = "MISSING_PAGE_2";
    CollectibleType[CollectibleType["CLEAR_RUNE"] = 263] = "CLEAR_RUNE";
    CollectibleType[CollectibleType["SMART_FLY"] = 264] = "SMART_FLY";
    CollectibleType[CollectibleType["DRY_BABY"] = 265] = "DRY_BABY";
    CollectibleType[CollectibleType["JUICY_SACK"] = 266] = "JUICY_SACK";
    CollectibleType[CollectibleType["ROBO_BABY_2"] = 267] = "ROBO_BABY_2";
    CollectibleType[CollectibleType["ROTTEN_BABY"] = 268] = "ROTTEN_BABY";
    CollectibleType[CollectibleType["HEADLESS_BABY"] = 269] = "HEADLESS_BABY";
    CollectibleType[CollectibleType["LEECH"] = 270] = "LEECH";
    CollectibleType[CollectibleType["MYSTERY_SACK"] = 271] = "MYSTERY_SACK";
    CollectibleType[CollectibleType["BBF"] = 272] = "BBF";
    CollectibleType[CollectibleType["BOBS_BRAIN"] = 273] = "BOBS_BRAIN";
    CollectibleType[CollectibleType["BEST_BUD"] = 274] = "BEST_BUD";
    CollectibleType[CollectibleType["LIL_BRIMSTONE"] = 275] = "LIL_BRIMSTONE";
    CollectibleType[CollectibleType["ISAACS_HEART"] = 276] = "ISAACS_HEART";
    CollectibleType[CollectibleType["LIL_HAUNT"] = 277] = "LIL_HAUNT";
    CollectibleType[CollectibleType["DARK_BUM"] = 278] = "DARK_BUM";
    CollectibleType[CollectibleType["BIG_FAN"] = 279] = "BIG_FAN";
    CollectibleType[CollectibleType["SISSY_LONGLEGS"] = 280] = "SISSY_LONGLEGS";
    CollectibleType[CollectibleType["PUNCHING_BAG"] = 281] = "PUNCHING_BAG";
    CollectibleType[CollectibleType["HOW_TO_JUMP"] = 282] = "HOW_TO_JUMP";
    CollectibleType[CollectibleType["D100"] = 283] = "D100";
    CollectibleType[CollectibleType["D4"] = 284] = "D4";
    CollectibleType[CollectibleType["D10"] = 285] = "D10";
    CollectibleType[CollectibleType["BLANK_CARD"] = 286] = "BLANK_CARD";
    CollectibleType[CollectibleType["BOOK_OF_SECRETS"] = 287] = "BOOK_OF_SECRETS";
    CollectibleType[CollectibleType["BOX_OF_SPIDERS"] = 288] = "BOX_OF_SPIDERS";
    CollectibleType[CollectibleType["RED_CANDLE"] = 289] = "RED_CANDLE";
    CollectibleType[CollectibleType["JAR"] = 290] = "JAR";
    CollectibleType[CollectibleType["FLUSH"] = 291] = "FLUSH";
    CollectibleType[CollectibleType["SATANIC_BIBLE"] = 292] = "SATANIC_BIBLE";
    CollectibleType[CollectibleType["HEAD_OF_KRAMPUS"] = 293] = "HEAD_OF_KRAMPUS";
    CollectibleType[CollectibleType["BUTTER_BEAN"] = 294] = "BUTTER_BEAN";
    CollectibleType[CollectibleType["MAGIC_FINGERS"] = 295] = "MAGIC_FINGERS";
    CollectibleType[CollectibleType["CONVERTER"] = 296] = "CONVERTER";
    CollectibleType[CollectibleType["BLUE_BOX"] = 297] = "BLUE_BOX";
    CollectibleType[CollectibleType["UNICORN_STUMP"] = 298] = "UNICORN_STUMP";
    CollectibleType[CollectibleType["TAURUS"] = 299] = "TAURUS";
    CollectibleType[CollectibleType["ARIES"] = 300] = "ARIES";
    CollectibleType[CollectibleType["CANCER"] = 301] = "CANCER";
    CollectibleType[CollectibleType["LEO"] = 302] = "LEO";
    CollectibleType[CollectibleType["VIRGO"] = 303] = "VIRGO";
    CollectibleType[CollectibleType["LIBRA"] = 304] = "LIBRA";
    CollectibleType[CollectibleType["SCORPIO"] = 305] = "SCORPIO";
    CollectibleType[CollectibleType["SAGITTARIUS"] = 306] = "SAGITTARIUS";
    CollectibleType[CollectibleType["CAPRICORN"] = 307] = "CAPRICORN";
    CollectibleType[CollectibleType["AQUARIUS"] = 308] = "AQUARIUS";
    CollectibleType[CollectibleType["PISCES"] = 309] = "PISCES";
    CollectibleType[CollectibleType["EVES_MASCARA"] = 310] = "EVES_MASCARA";
    CollectibleType[CollectibleType["JUDAS_SHADOW"] = 311] = "JUDAS_SHADOW";
    CollectibleType[CollectibleType["MAGGYS_BOW"] = 312] = "MAGGYS_BOW";
    CollectibleType[CollectibleType["HOLY_MANTLE"] = 313] = "HOLY_MANTLE";
    CollectibleType[CollectibleType["THUNDER_THIGHS"] = 314] = "THUNDER_THIGHS";
    CollectibleType[CollectibleType["STRANGE_ATTRACTOR"] = 315] = "STRANGE_ATTRACTOR";
    CollectibleType[CollectibleType["CURSED_EYE"] = 316] = "CURSED_EYE";
    CollectibleType[CollectibleType["MYSTERIOUS_LIQUID"] = 317] = "MYSTERIOUS_LIQUID";
    CollectibleType[CollectibleType["GEMINI"] = 318] = "GEMINI";
    CollectibleType[CollectibleType["CAINS_OTHER_EYE"] = 319] = "CAINS_OTHER_EYE";
    CollectibleType[CollectibleType["BLUE_BABYS_ONLY_FRIEND"] = 320] = "BLUE_BABYS_ONLY_FRIEND";
    CollectibleType[CollectibleType["SAMSONS_CHAINS"] = 321] = "SAMSONS_CHAINS";
    CollectibleType[CollectibleType["MONGO_BABY"] = 322] = "MONGO_BABY";
    CollectibleType[CollectibleType["ISAACS_TEARS"] = 323] = "ISAACS_TEARS";
    CollectibleType[CollectibleType["UNDEFINED"] = 324] = "UNDEFINED";
    CollectibleType[CollectibleType["SCISSORS"] = 325] = "SCISSORS";
    CollectibleType[CollectibleType["BREATH_OF_LIFE"] = 326] = "BREATH_OF_LIFE";
    CollectibleType[CollectibleType["POLAROID"] = 327] = "POLAROID";
    CollectibleType[CollectibleType["NEGATIVE"] = 328] = "NEGATIVE";
    CollectibleType[CollectibleType["LUDOVICO_TECHNIQUE"] = 329] = "LUDOVICO_TECHNIQUE";
    CollectibleType[CollectibleType["SOY_MILK"] = 330] = "SOY_MILK";
    CollectibleType[CollectibleType["GODHEAD"] = 331] = "GODHEAD";
    CollectibleType[CollectibleType["LAZARUS_RAGS"] = 332] = "LAZARUS_RAGS";
    CollectibleType[CollectibleType["MIND"] = 333] = "MIND";
    CollectibleType[CollectibleType["BODY"] = 334] = "BODY";
    CollectibleType[CollectibleType["SOUL"] = 335] = "SOUL";
    CollectibleType[CollectibleType["DEAD_ONION"] = 336] = "DEAD_ONION";
    CollectibleType[CollectibleType["BROKEN_WATCH"] = 337] = "BROKEN_WATCH";
    CollectibleType[CollectibleType["BOOMERANG"] = 338] = "BOOMERANG";
    CollectibleType[CollectibleType["SAFETY_PIN"] = 339] = "SAFETY_PIN";
    CollectibleType[CollectibleType["CAFFEINE_PILL"] = 340] = "CAFFEINE_PILL";
    CollectibleType[CollectibleType["TORN_PHOTO"] = 341] = "TORN_PHOTO";
    CollectibleType[CollectibleType["BLUE_CAP"] = 342] = "BLUE_CAP";
    CollectibleType[CollectibleType["LATCH_KEY"] = 343] = "LATCH_KEY";
    CollectibleType[CollectibleType["MATCH_BOOK"] = 344] = "MATCH_BOOK";
    CollectibleType[CollectibleType["SYNTHOIL"] = 345] = "SYNTHOIL";
    CollectibleType[CollectibleType["SNACK"] = 346] = "SNACK";
    CollectibleType[CollectibleType["DIPLOPIA"] = 347] = "DIPLOPIA";
    CollectibleType[CollectibleType["PLACEBO"] = 348] = "PLACEBO";
    CollectibleType[CollectibleType["WOODEN_NICKEL"] = 349] = "WOODEN_NICKEL";
    CollectibleType[CollectibleType["TOXIC_SHOCK"] = 350] = "TOXIC_SHOCK";
    CollectibleType[CollectibleType["MEGA_BEAN"] = 351] = "MEGA_BEAN";
    CollectibleType[CollectibleType["GLASS_CANNON"] = 352] = "GLASS_CANNON";
    CollectibleType[CollectibleType["BOMBER_BOY"] = 353] = "BOMBER_BOY";
    CollectibleType[CollectibleType["CRACK_JACKS"] = 354] = "CRACK_JACKS";
    CollectibleType[CollectibleType["MOMS_PEARLS"] = 355] = "MOMS_PEARLS";
    CollectibleType[CollectibleType["CAR_BATTERY"] = 356] = "CAR_BATTERY";
    CollectibleType[CollectibleType["BOX_OF_FRIENDS"] = 357] = "BOX_OF_FRIENDS";
    CollectibleType[CollectibleType["WIZ"] = 358] = "WIZ";
    CollectibleType[CollectibleType["EIGHT_INCH_NAILS"] = 359] = "EIGHT_INCH_NAILS";
    CollectibleType[CollectibleType["INCUBUS"] = 360] = "INCUBUS";
    CollectibleType[CollectibleType["FATES_REWARD"] = 361] = "FATES_REWARD";
    CollectibleType[CollectibleType["LIL_CHEST"] = 362] = "LIL_CHEST";
    CollectibleType[CollectibleType["SWORN_PROTECTOR"] = 363] = "SWORN_PROTECTOR";
    CollectibleType[CollectibleType["FRIEND_ZONE"] = 364] = "FRIEND_ZONE";
    CollectibleType[CollectibleType["LOST_FLY"] = 365] = "LOST_FLY";
    CollectibleType[CollectibleType["SCATTER_BOMBS"] = 366] = "SCATTER_BOMBS";
    CollectibleType[CollectibleType["STICKY_BOMBS"] = 367] = "STICKY_BOMBS";
    CollectibleType[CollectibleType["EPIPHORA"] = 368] = "EPIPHORA";
    CollectibleType[CollectibleType["CONTINUUM"] = 369] = "CONTINUUM";
    CollectibleType[CollectibleType["MR_DOLLY"] = 370] = "MR_DOLLY";
    CollectibleType[CollectibleType["CURSE_OF_THE_TOWER"] = 371] = "CURSE_OF_THE_TOWER";
    CollectibleType[CollectibleType["CHARGED_BABY"] = 372] = "CHARGED_BABY";
    CollectibleType[CollectibleType["DEAD_EYE"] = 373] = "DEAD_EYE";
    CollectibleType[CollectibleType["HOLY_LIGHT"] = 374] = "HOLY_LIGHT";
    CollectibleType[CollectibleType["HOST_HAT"] = 375] = "HOST_HAT";
    CollectibleType[CollectibleType["RESTOCK"] = 376] = "RESTOCK";
    CollectibleType[CollectibleType["BURSTING_SACK"] = 377] = "BURSTING_SACK";
    CollectibleType[CollectibleType["NUMBER_TWO"] = 378] = "NUMBER_TWO";
    CollectibleType[CollectibleType["PUPULA_DUPLEX"] = 379] = "PUPULA_DUPLEX";
    CollectibleType[CollectibleType["PAY_TO_PLAY"] = 380] = "PAY_TO_PLAY";
    CollectibleType[CollectibleType["EDENS_BLESSING"] = 381] = "EDENS_BLESSING";
    CollectibleType[CollectibleType["FRIEND_BALL"] = 382] = "FRIEND_BALL";
    CollectibleType[CollectibleType["TEAR_DETONATOR"] = 383] = "TEAR_DETONATOR";
    CollectibleType[CollectibleType["LIL_GURDY"] = 384] = "LIL_GURDY";
    CollectibleType[CollectibleType["BUMBO"] = 385] = "BUMBO";
    CollectibleType[CollectibleType["D12"] = 386] = "D12";
    CollectibleType[CollectibleType["CENSER"] = 387] = "CENSER";
    CollectibleType[CollectibleType["KEY_BUM"] = 388] = "KEY_BUM";
    CollectibleType[CollectibleType["RUNE_BAG"] = 389] = "RUNE_BAG";
    CollectibleType[CollectibleType["SERAPHIM"] = 390] = "SERAPHIM";
    CollectibleType[CollectibleType["BETRAYAL"] = 391] = "BETRAYAL";
    CollectibleType[CollectibleType["ZODIAC"] = 392] = "ZODIAC";
    CollectibleType[CollectibleType["SERPENTS_KISS"] = 393] = "SERPENTS_KISS";
    CollectibleType[CollectibleType["MARKED"] = 394] = "MARKED";
    CollectibleType[CollectibleType["TECH_X"] = 395] = "TECH_X";
    CollectibleType[CollectibleType["VENTRICLE_RAZOR"] = 396] = "VENTRICLE_RAZOR";
    CollectibleType[CollectibleType["TRACTOR_BEAM"] = 397] = "TRACTOR_BEAM";
    CollectibleType[CollectibleType["GODS_FLESH"] = 398] = "GODS_FLESH";
    CollectibleType[CollectibleType["MAW_OF_THE_VOID"] = 399] = "MAW_OF_THE_VOID";
    CollectibleType[CollectibleType["SPEAR_OF_DESTINY"] = 400] = "SPEAR_OF_DESTINY";
    CollectibleType[CollectibleType["EXPLOSIVO"] = 401] = "EXPLOSIVO";
    CollectibleType[CollectibleType["CHAOS"] = 402] = "CHAOS";
    CollectibleType[CollectibleType["SPIDER_MOD"] = 403] = "SPIDER_MOD";
    CollectibleType[CollectibleType["FARTING_BABY"] = 404] = "FARTING_BABY";
    CollectibleType[CollectibleType["GB_BUG"] = 405] = "GB_BUG";
    CollectibleType[CollectibleType["D8"] = 406] = "D8";
    CollectibleType[CollectibleType["PURITY"] = 407] = "PURITY";
    CollectibleType[CollectibleType["ATHAME"] = 408] = "ATHAME";
    CollectibleType[CollectibleType["EMPTY_VESSEL"] = 409] = "EMPTY_VESSEL";
    CollectibleType[CollectibleType["EVIL_EYE"] = 410] = "EVIL_EYE";
    CollectibleType[CollectibleType["LUSTY_BLOOD"] = 411] = "LUSTY_BLOOD";
    CollectibleType[CollectibleType["CAMBION_CONCEPTION"] = 412] = "CAMBION_CONCEPTION";
    CollectibleType[CollectibleType["IMMACULATE_CONCEPTION"] = 413] = "IMMACULATE_CONCEPTION";
    CollectibleType[CollectibleType["MORE_OPTIONS"] = 414] = "MORE_OPTIONS";
    CollectibleType[CollectibleType["CROWN_OF_LIGHT"] = 415] = "CROWN_OF_LIGHT";
    CollectibleType[CollectibleType["DEEP_POCKETS"] = 416] = "DEEP_POCKETS";
    CollectibleType[CollectibleType["SUCCUBUS"] = 417] = "SUCCUBUS";
    CollectibleType[CollectibleType["FRUIT_CAKE"] = 418] = "FRUIT_CAKE";
    CollectibleType[CollectibleType["TELEPORT_2"] = 419] = "TELEPORT_2";
    CollectibleType[CollectibleType["BLACK_POWDER"] = 420] = "BLACK_POWDER";
    CollectibleType[CollectibleType["KIDNEY_BEAN"] = 421] = "KIDNEY_BEAN";
    CollectibleType[CollectibleType["GLOWING_HOUR_GLASS"] = 422] = "GLOWING_HOUR_GLASS";
    CollectibleType[CollectibleType["CIRCLE_OF_PROTECTION"] = 423] = "CIRCLE_OF_PROTECTION";
    CollectibleType[CollectibleType["SACK_HEAD"] = 424] = "SACK_HEAD";
    CollectibleType[CollectibleType["NIGHT_LIGHT"] = 425] = "NIGHT_LIGHT";
    CollectibleType[CollectibleType["OBSESSED_FAN"] = 426] = "OBSESSED_FAN";
    CollectibleType[CollectibleType["MINE_CRAFTER"] = 427] = "MINE_CRAFTER";
    CollectibleType[CollectibleType["PJS"] = 428] = "PJS";
    CollectibleType[CollectibleType["HEAD_OF_THE_KEEPER"] = 429] = "HEAD_OF_THE_KEEPER";
    CollectibleType[CollectibleType["PAPA_FLY"] = 430] = "PAPA_FLY";
    CollectibleType[CollectibleType["MULTIDIMENSIONAL_BABY"] = 431] = "MULTIDIMENSIONAL_BABY";
    CollectibleType[CollectibleType["GLITTER_BOMBS"] = 432] = "GLITTER_BOMBS";
    CollectibleType[CollectibleType["MY_SHADOW"] = 433] = "MY_SHADOW";
    CollectibleType[CollectibleType["JAR_OF_FLIES"] = 434] = "JAR_OF_FLIES";
    CollectibleType[CollectibleType["LIL_LOKI"] = 435] = "LIL_LOKI";
    CollectibleType[CollectibleType["MILK"] = 436] = "MILK";
    CollectibleType[CollectibleType["D7"] = 437] = "D7";
    CollectibleType[CollectibleType["BINKY"] = 438] = "BINKY";
    CollectibleType[CollectibleType["MOMS_BOX"] = 439] = "MOMS_BOX";
    CollectibleType[CollectibleType["KIDNEY_STONE"] = 440] = "KIDNEY_STONE";
    CollectibleType[CollectibleType["MEGA_BLAST"] = 441] = "MEGA_BLAST";
    CollectibleType[CollectibleType["DARK_PRINCES_CROWN"] = 442] = "DARK_PRINCES_CROWN";
    CollectibleType[CollectibleType["APPLE"] = 443] = "APPLE";
    CollectibleType[CollectibleType["LEAD_PENCIL"] = 444] = "LEAD_PENCIL";
    CollectibleType[CollectibleType["DOG_TOOTH"] = 445] = "DOG_TOOTH";
    CollectibleType[CollectibleType["DEAD_TOOTH"] = 446] = "DEAD_TOOTH";
    CollectibleType[CollectibleType["LINGER_BEAN"] = 447] = "LINGER_BEAN";
    CollectibleType[CollectibleType["SHARD_OF_GLASS"] = 448] = "SHARD_OF_GLASS";
    CollectibleType[CollectibleType["METAL_PLATE"] = 449] = "METAL_PLATE";
    CollectibleType[CollectibleType["EYE_OF_GREED"] = 450] = "EYE_OF_GREED";
    CollectibleType[CollectibleType["TAROT_CLOTH"] = 451] = "TAROT_CLOTH";
    CollectibleType[CollectibleType["VARICOSE_VEINS"] = 452] = "VARICOSE_VEINS";
    CollectibleType[CollectibleType["COMPOUND_FRACTURE"] = 453] = "COMPOUND_FRACTURE";
    CollectibleType[CollectibleType["POLYDACTYLY"] = 454] = "POLYDACTYLY";
    CollectibleType[CollectibleType["DADS_LOST_COIN"] = 455] = "DADS_LOST_COIN";
    CollectibleType[CollectibleType["MIDNIGHT_SNACK"] = 456] = "MIDNIGHT_SNACK";
    CollectibleType[CollectibleType["CONE_HEAD"] = 457] = "CONE_HEAD";
    CollectibleType[CollectibleType["BELLY_BUTTON"] = 458] = "BELLY_BUTTON";
    CollectibleType[CollectibleType["SINUS_INFECTION"] = 459] = "SINUS_INFECTION";
    CollectibleType[CollectibleType["GLAUCOMA"] = 460] = "GLAUCOMA";
    CollectibleType[CollectibleType["PARASITOID"] = 461] = "PARASITOID";
    CollectibleType[CollectibleType["EYE_OF_BELIAL"] = 462] = "EYE_OF_BELIAL";
    CollectibleType[CollectibleType["SULFURIC_ACID"] = 463] = "SULFURIC_ACID";
    CollectibleType[CollectibleType["GLYPH_OF_BALANCE"] = 464] = "GLYPH_OF_BALANCE";
    CollectibleType[CollectibleType["ANALOG_STICK"] = 465] = "ANALOG_STICK";
    CollectibleType[CollectibleType["CONTAGION"] = 466] = "CONTAGION";
    CollectibleType[CollectibleType["FINGER"] = 467] = "FINGER";
    CollectibleType[CollectibleType["SHADE"] = 468] = "SHADE";
    CollectibleType[CollectibleType["DEPRESSION"] = 469] = "DEPRESSION";
    CollectibleType[CollectibleType["HUSHY"] = 470] = "HUSHY";
    CollectibleType[CollectibleType["LIL_MONSTRO"] = 471] = "LIL_MONSTRO";
    CollectibleType[CollectibleType["KING_BABY"] = 472] = "KING_BABY";
    CollectibleType[CollectibleType["BIG_CHUBBY"] = 473] = "BIG_CHUBBY";
    CollectibleType[CollectibleType["BROKEN_GLASS_CANNON"] = 474] = "BROKEN_GLASS_CANNON";
    CollectibleType[CollectibleType["PLAN_C"] = 475] = "PLAN_C";
    CollectibleType[CollectibleType["D1"] = 476] = "D1";
    CollectibleType[CollectibleType["VOID"] = 477] = "VOID";
    CollectibleType[CollectibleType["PAUSE"] = 478] = "PAUSE";
    CollectibleType[CollectibleType["SMELTER"] = 479] = "SMELTER";
    CollectibleType[CollectibleType["COMPOST"] = 480] = "COMPOST";
    CollectibleType[CollectibleType["DATAMINER"] = 481] = "DATAMINER";
    CollectibleType[CollectibleType["CLICKER"] = 482] = "CLICKER";
    CollectibleType[CollectibleType["MAMA_MEGA"] = 483] = "MAMA_MEGA";
    CollectibleType[CollectibleType["WAIT_WHAT"] = 484] = "WAIT_WHAT";
    CollectibleType[CollectibleType["CROOKED_PENNY"] = 485] = "CROOKED_PENNY";
    CollectibleType[CollectibleType["DULL_RAZOR"] = 486] = "DULL_RAZOR";
    CollectibleType[CollectibleType["POTATO_PEELER"] = 487] = "POTATO_PEELER";
    CollectibleType[CollectibleType["METRONOME"] = 488] = "METRONOME";
    CollectibleType[CollectibleType["D_INFINITY"] = 489] = "D_INFINITY";
    CollectibleType[CollectibleType["EDENS_SOUL"] = 490] = "EDENS_SOUL";
    CollectibleType[CollectibleType["ACID_BABY"] = 491] = "ACID_BABY";
    CollectibleType[CollectibleType["YO_LISTEN"] = 492] = "YO_LISTEN";
    CollectibleType[CollectibleType["ADRENALINE"] = 493] = "ADRENALINE";
    CollectibleType[CollectibleType["JACOBS_LADDER"] = 494] = "JACOBS_LADDER";
    CollectibleType[CollectibleType["GHOST_PEPPER"] = 495] = "GHOST_PEPPER";
    CollectibleType[CollectibleType["EUTHANASIA"] = 496] = "EUTHANASIA";
    CollectibleType[CollectibleType["CAMO_UNDIES"] = 497] = "CAMO_UNDIES";
    CollectibleType[CollectibleType["DUALITY"] = 498] = "DUALITY";
    CollectibleType[CollectibleType["EUCHARIST"] = 499] = "EUCHARIST";
    CollectibleType[CollectibleType["SACK_OF_SACKS"] = 500] = "SACK_OF_SACKS";
    CollectibleType[CollectibleType["GREEDS_GULLET"] = 501] = "GREEDS_GULLET";
    CollectibleType[CollectibleType["LARGE_ZIT"] = 502] = "LARGE_ZIT";
    CollectibleType[CollectibleType["LITTLE_HORN"] = 503] = "LITTLE_HORN";
    CollectibleType[CollectibleType["BROWN_NUGGET"] = 504] = "BROWN_NUGGET";
    CollectibleType[CollectibleType["POKE_GO"] = 505] = "POKE_GO";
    CollectibleType[CollectibleType["BACKSTABBER"] = 506] = "BACKSTABBER";
    CollectibleType[CollectibleType["SHARP_STRAW"] = 507] = "SHARP_STRAW";
    CollectibleType[CollectibleType["MOMS_RAZOR"] = 508] = "MOMS_RAZOR";
    CollectibleType[CollectibleType["BLOODSHOT_EYE"] = 509] = "BLOODSHOT_EYE";
    CollectibleType[CollectibleType["DELIRIOUS"] = 510] = "DELIRIOUS";
    CollectibleType[CollectibleType["ANGRY_FLY"] = 511] = "ANGRY_FLY";
    CollectibleType[CollectibleType["BLACK_HOLE"] = 512] = "BLACK_HOLE";
    CollectibleType[CollectibleType["BOZO"] = 513] = "BOZO";
    CollectibleType[CollectibleType["BROKEN_MODEM"] = 514] = "BROKEN_MODEM";
    CollectibleType[CollectibleType["MYSTERY_GIFT"] = 515] = "MYSTERY_GIFT";
    CollectibleType[CollectibleType["SPRINKLER"] = 516] = "SPRINKLER";
    CollectibleType[CollectibleType["FAST_BOMBS"] = 517] = "FAST_BOMBS";
    CollectibleType[CollectibleType["BUDDY_IN_A_BOX"] = 518] = "BUDDY_IN_A_BOX";
    CollectibleType[CollectibleType["LIL_DELIRIUM"] = 519] = "LIL_DELIRIUM";
    CollectibleType[CollectibleType["JUMPER_CABLES"] = 520] = "JUMPER_CABLES";
    CollectibleType[CollectibleType["COUPON"] = 521] = "COUPON";
    CollectibleType[CollectibleType["TELEKINESIS"] = 522] = "TELEKINESIS";
    CollectibleType[CollectibleType["MOVING_BOX"] = 523] = "MOVING_BOX";
    CollectibleType[CollectibleType["TECHNOLOGY_ZERO"] = 524] = "TECHNOLOGY_ZERO";
    CollectibleType[CollectibleType["LEPROSY"] = 525] = "LEPROSY";
    CollectibleType[CollectibleType["SEVEN_SEALS"] = 526] = "SEVEN_SEALS";
    CollectibleType[CollectibleType["MR_ME"] = 527] = "MR_ME";
    CollectibleType[CollectibleType["ANGELIC_PRISM"] = 528] = "ANGELIC_PRISM";
    CollectibleType[CollectibleType["POP"] = 529] = "POP";
    CollectibleType[CollectibleType["DEATHS_LIST"] = 530] = "DEATHS_LIST";
    CollectibleType[CollectibleType["HAEMOLACRIA"] = 531] = "HAEMOLACRIA";
    CollectibleType[CollectibleType["LACHRYPHAGY"] = 532] = "LACHRYPHAGY";
    CollectibleType[CollectibleType["TRISAGION"] = 533] = "TRISAGION";
    CollectibleType[CollectibleType["SCHOOLBAG"] = 534] = "SCHOOLBAG";
    CollectibleType[CollectibleType["BLANKET"] = 535] = "BLANKET";
    CollectibleType[CollectibleType["SACRIFICIAL_ALTAR"] = 536] = "SACRIFICIAL_ALTAR";
    CollectibleType[CollectibleType["LIL_SPEWER"] = 537] = "LIL_SPEWER";
    CollectibleType[CollectibleType["MARBLES"] = 538] = "MARBLES";
    CollectibleType[CollectibleType["MYSTERY_EGG"] = 539] = "MYSTERY_EGG";
    CollectibleType[CollectibleType["FLAT_STONE"] = 540] = "FLAT_STONE";
    CollectibleType[CollectibleType["MARROW"] = 541] = "MARROW";
    CollectibleType[CollectibleType["SLIPPED_RIB"] = 542] = "SLIPPED_RIB";
    CollectibleType[CollectibleType["HALLOWED_GROUND"] = 543] = "HALLOWED_GROUND";
    CollectibleType[CollectibleType["POINTY_RIB"] = 544] = "POINTY_RIB";
    CollectibleType[CollectibleType["BOOK_OF_THE_DEAD"] = 545] = "BOOK_OF_THE_DEAD";
    CollectibleType[CollectibleType["DADS_RING"] = 546] = "DADS_RING";
    CollectibleType[CollectibleType["DIVORCE_PAPERS"] = 547] = "DIVORCE_PAPERS";
    CollectibleType[CollectibleType["JAW_BONE"] = 548] = "JAW_BONE";
    CollectibleType[CollectibleType["BRITTLE_BONES"] = 549] = "BRITTLE_BONES";
    CollectibleType[CollectibleType["BROKEN_SHOVEL_1"] = 550] = "BROKEN_SHOVEL_1";
    CollectibleType[CollectibleType["BROKEN_SHOVEL_2"] = 551] = "BROKEN_SHOVEL_2";
    CollectibleType[CollectibleType["MOMS_SHOVEL"] = 552] = "MOMS_SHOVEL";
    CollectibleType[CollectibleType["MUCORMYCOSIS"] = 553] = "MUCORMYCOSIS";
    CollectibleType[CollectibleType["TWO_SPOOKY"] = 554] = "TWO_SPOOKY";
    CollectibleType[CollectibleType["GOLDEN_RAZOR"] = 555] = "GOLDEN_RAZOR";
    CollectibleType[CollectibleType["SULFUR"] = 556] = "SULFUR";
    CollectibleType[CollectibleType["FORTUNE_COOKIE"] = 557] = "FORTUNE_COOKIE";
    CollectibleType[CollectibleType["EYE_SORE"] = 558] = "EYE_SORE";
    CollectibleType[CollectibleType["ONE_HUNDRED_TWENTY_VOLT"] = 559] = "ONE_HUNDRED_TWENTY_VOLT";
    CollectibleType[CollectibleType["IT_HURTS"] = 560] = "IT_HURTS";
    CollectibleType[CollectibleType["ALMOND_MILK"] = 561] = "ALMOND_MILK";
    CollectibleType[CollectibleType["ROCK_BOTTOM"] = 562] = "ROCK_BOTTOM";
    CollectibleType[CollectibleType["NANCY_BOMBS"] = 563] = "NANCY_BOMBS";
    CollectibleType[CollectibleType["BAR_OF_SOAP"] = 564] = "BAR_OF_SOAP";
    CollectibleType[CollectibleType["BLOOD_PUPPY"] = 565] = "BLOOD_PUPPY";
    CollectibleType[CollectibleType["DREAM_CATCHER"] = 566] = "DREAM_CATCHER";
    CollectibleType[CollectibleType["PASCHAL_CANDLE"] = 567] = "PASCHAL_CANDLE";
    CollectibleType[CollectibleType["DIVINE_INTERVENTION"] = 568] = "DIVINE_INTERVENTION";
    CollectibleType[CollectibleType["BLOOD_OATH"] = 569] = "BLOOD_OATH";
    CollectibleType[CollectibleType["PLAYDOUGH_COOKIE"] = 570] = "PLAYDOUGH_COOKIE";
    CollectibleType[CollectibleType["ORPHAN_SOCKS"] = 571] = "ORPHAN_SOCKS";
    CollectibleType[CollectibleType["EYE_OF_THE_OCCULT"] = 572] = "EYE_OF_THE_OCCULT";
    CollectibleType[CollectibleType["IMMACULATE_HEART"] = 573] = "IMMACULATE_HEART";
    CollectibleType[CollectibleType["MONSTRANCE"] = 574] = "MONSTRANCE";
    CollectibleType[CollectibleType["INTRUDER"] = 575] = "INTRUDER";
    CollectibleType[CollectibleType["DIRTY_MIND"] = 576] = "DIRTY_MIND";
    CollectibleType[CollectibleType["DAMOCLES"] = 577] = "DAMOCLES";
    CollectibleType[CollectibleType["FREE_LEMONADE"] = 578] = "FREE_LEMONADE";
    CollectibleType[CollectibleType["SPIRIT_SWORD"] = 579] = "SPIRIT_SWORD";
    CollectibleType[CollectibleType["RED_KEY"] = 580] = "RED_KEY";
    CollectibleType[CollectibleType["PSY_FLY"] = 581] = "PSY_FLY";
    CollectibleType[CollectibleType["WAVY_CAP"] = 582] = "WAVY_CAP";
    CollectibleType[CollectibleType["ROCKET_IN_A_JAR"] = 583] = "ROCKET_IN_A_JAR";
    CollectibleType[CollectibleType["BOOK_OF_VIRTUES"] = 584] = "BOOK_OF_VIRTUES";
    CollectibleType[CollectibleType["ALABASTER_BOX"] = 585] = "ALABASTER_BOX";
    CollectibleType[CollectibleType["STAIRWAY"] = 586] = "STAIRWAY";
    // - There is no enum member with a value of 587. (This used to be the ID for Menorah before it
    //   was cut from Repentance.)
    CollectibleType[CollectibleType["SOL"] = 588] = "SOL";
    CollectibleType[CollectibleType["LUNA"] = 589] = "LUNA";
    CollectibleType[CollectibleType["MERCURIUS"] = 590] = "MERCURIUS";
    CollectibleType[CollectibleType["VENUS"] = 591] = "VENUS";
    CollectibleType[CollectibleType["TERRA"] = 592] = "TERRA";
    CollectibleType[CollectibleType["MARS"] = 593] = "MARS";
    CollectibleType[CollectibleType["JUPITER"] = 594] = "JUPITER";
    CollectibleType[CollectibleType["SATURNUS"] = 595] = "SATURNUS";
    CollectibleType[CollectibleType["URANUS"] = 596] = "URANUS";
    CollectibleType[CollectibleType["NEPTUNUS"] = 597] = "NEPTUNUS";
    CollectibleType[CollectibleType["PLUTO"] = 598] = "PLUTO";
    CollectibleType[CollectibleType["VOODOO_HEAD"] = 599] = "VOODOO_HEAD";
    CollectibleType[CollectibleType["EYE_DROPS"] = 600] = "EYE_DROPS";
    CollectibleType[CollectibleType["ACT_OF_CONTRITION"] = 601] = "ACT_OF_CONTRITION";
    CollectibleType[CollectibleType["MEMBER_CARD"] = 602] = "MEMBER_CARD";
    CollectibleType[CollectibleType["BATTERY_PACK"] = 603] = "BATTERY_PACK";
    CollectibleType[CollectibleType["MOMS_BRACELET"] = 604] = "MOMS_BRACELET";
    CollectibleType[CollectibleType["SCOOPER"] = 605] = "SCOOPER";
    CollectibleType[CollectibleType["OCULAR_RIFT"] = 606] = "OCULAR_RIFT";
    CollectibleType[CollectibleType["BOILED_BABY"] = 607] = "BOILED_BABY";
    CollectibleType[CollectibleType["FREEZER_BABY"] = 608] = "FREEZER_BABY";
    CollectibleType[CollectibleType["ETERNAL_D6"] = 609] = "ETERNAL_D6";
    CollectibleType[CollectibleType["BIRD_CAGE"] = 610] = "BIRD_CAGE";
    CollectibleType[CollectibleType["LARYNX"] = 611] = "LARYNX";
    CollectibleType[CollectibleType["LOST_SOUL"] = 612] = "LOST_SOUL";
    // - There is no enum member with a value of 613. (This used to be the ID for Salt Shaker before
    //   it was cut from Repentance.)
    CollectibleType[CollectibleType["BLOOD_BOMBS"] = 614] = "BLOOD_BOMBS";
    CollectibleType[CollectibleType["LIL_DUMPY"] = 615] = "LIL_DUMPY";
    CollectibleType[CollectibleType["BIRDS_EYE"] = 616] = "BIRDS_EYE";
    CollectibleType[CollectibleType["LODESTONE"] = 617] = "LODESTONE";
    CollectibleType[CollectibleType["ROTTEN_TOMATO"] = 618] = "ROTTEN_TOMATO";
    CollectibleType[CollectibleType["BIRTHRIGHT"] = 619] = "BIRTHRIGHT";
    // - There is no enum member with a value of 620. (This used to be the ID for Voodoo Pin before it
    //   was cut from Repentance.)
    CollectibleType[CollectibleType["RED_STEW"] = 621] = "RED_STEW";
    CollectibleType[CollectibleType["GENESIS"] = 622] = "GENESIS";
    CollectibleType[CollectibleType["SHARP_KEY"] = 623] = "SHARP_KEY";
    CollectibleType[CollectibleType["BOOSTER_PACK"] = 624] = "BOOSTER_PACK";
    CollectibleType[CollectibleType["MEGA_MUSH"] = 625] = "MEGA_MUSH";
    CollectibleType[CollectibleType["KNIFE_PIECE_1"] = 626] = "KNIFE_PIECE_1";
    CollectibleType[CollectibleType["KNIFE_PIECE_2"] = 627] = "KNIFE_PIECE_2";
    CollectibleType[CollectibleType["DEATH_CERTIFICATE"] = 628] = "DEATH_CERTIFICATE";
    CollectibleType[CollectibleType["BOT_FLY"] = 629] = "BOT_FLY";
    // - There is no enum member with a value of 630. (This used to be the ID for Lucky Seven before
    //   it was cut from Repentance.)
    CollectibleType[CollectibleType["MEAT_CLEAVER"] = 631] = "MEAT_CLEAVER";
    CollectibleType[CollectibleType["EVIL_CHARM"] = 632] = "EVIL_CHARM";
    CollectibleType[CollectibleType["DOGMA"] = 633] = "DOGMA";
    CollectibleType[CollectibleType["PURGATORY"] = 634] = "PURGATORY";
    CollectibleType[CollectibleType["STITCHES"] = 635] = "STITCHES";
    CollectibleType[CollectibleType["R_KEY"] = 636] = "R_KEY";
    CollectibleType[CollectibleType["KNOCKOUT_DROPS"] = 637] = "KNOCKOUT_DROPS";
    CollectibleType[CollectibleType["ERASER"] = 638] = "ERASER";
    CollectibleType[CollectibleType["YUCK_HEART"] = 639] = "YUCK_HEART";
    CollectibleType[CollectibleType["URN_OF_SOULS"] = 640] = "URN_OF_SOULS";
    CollectibleType[CollectibleType["AKELDAMA"] = 641] = "AKELDAMA";
    CollectibleType[CollectibleType["MAGIC_SKIN"] = 642] = "MAGIC_SKIN";
    CollectibleType[CollectibleType["REVELATION"] = 643] = "REVELATION";
    CollectibleType[CollectibleType["CONSOLATION_PRIZE"] = 644] = "CONSOLATION_PRIZE";
    CollectibleType[CollectibleType["TINYTOMA"] = 645] = "TINYTOMA";
    CollectibleType[CollectibleType["BRIMSTONE_BOMBS"] = 646] = "BRIMSTONE_BOMBS";
    CollectibleType[CollectibleType["FOUR_FIVE_VOLT"] = 647] = "FOUR_FIVE_VOLT";
    // - There is no enum member with a value of 648. (This used to be the ID for Pill Crusher before
    //   it was cut from Repentance.)
    CollectibleType[CollectibleType["FRUITY_PLUM"] = 649] = "FRUITY_PLUM";
    CollectibleType[CollectibleType["PLUM_FLUTE"] = 650] = "PLUM_FLUTE";
    CollectibleType[CollectibleType["STAR_OF_BETHLEHEM"] = 651] = "STAR_OF_BETHLEHEM";
    CollectibleType[CollectibleType["CUBE_BABY"] = 652] = "CUBE_BABY";
    CollectibleType[CollectibleType["VADE_RETRO"] = 653] = "VADE_RETRO";
    CollectibleType[CollectibleType["FALSE_PHD"] = 654] = "FALSE_PHD";
    CollectibleType[CollectibleType["SPIN_TO_WIN"] = 655] = "SPIN_TO_WIN";
    CollectibleType[CollectibleType["DAMOCLES_PASSIVE"] = 656] = "DAMOCLES_PASSIVE";
    CollectibleType[CollectibleType["VASCULITIS"] = 657] = "VASCULITIS";
    CollectibleType[CollectibleType["GIANT_CELL"] = 658] = "GIANT_CELL";
    CollectibleType[CollectibleType["TROPICAMIDE"] = 659] = "TROPICAMIDE";
    CollectibleType[CollectibleType["CARD_READING"] = 660] = "CARD_READING";
    CollectibleType[CollectibleType["QUINTS"] = 661] = "QUINTS";
    // - There is no enum member with a value of 662.
    CollectibleType[CollectibleType["TOOTH_AND_NAIL"] = 663] = "TOOTH_AND_NAIL";
    CollectibleType[CollectibleType["BINGE_EATER"] = 664] = "BINGE_EATER";
    CollectibleType[CollectibleType["GUPPYS_EYE"] = 665] = "GUPPYS_EYE";
    // - There is no enum member with a value of 666.
    CollectibleType[CollectibleType["STRAWMAN"] = 667] = "STRAWMAN";
    CollectibleType[CollectibleType["DADS_NOTE"] = 668] = "DADS_NOTE";
    CollectibleType[CollectibleType["SAUSAGE"] = 669] = "SAUSAGE";
    CollectibleType[CollectibleType["OPTIONS"] = 670] = "OPTIONS";
    CollectibleType[CollectibleType["CANDY_HEART"] = 671] = "CANDY_HEART";
    CollectibleType[CollectibleType["POUND_OF_FLESH"] = 672] = "POUND_OF_FLESH";
    CollectibleType[CollectibleType["REDEMPTION"] = 673] = "REDEMPTION";
    CollectibleType[CollectibleType["SPIRIT_SHACKLES"] = 674] = "SPIRIT_SHACKLES";
    CollectibleType[CollectibleType["CRACKED_ORB"] = 675] = "CRACKED_ORB";
    CollectibleType[CollectibleType["EMPTY_HEART"] = 676] = "EMPTY_HEART";
    CollectibleType[CollectibleType["ASTRAL_PROJECTION"] = 677] = "ASTRAL_PROJECTION";
    CollectibleType[CollectibleType["C_SECTION"] = 678] = "C_SECTION";
    CollectibleType[CollectibleType["LIL_ABADDON"] = 679] = "LIL_ABADDON";
    CollectibleType[CollectibleType["MONTEZUMAS_REVENGE"] = 680] = "MONTEZUMAS_REVENGE";
    CollectibleType[CollectibleType["LIL_PORTAL"] = 681] = "LIL_PORTAL";
    CollectibleType[CollectibleType["WORM_FRIEND"] = 682] = "WORM_FRIEND";
    CollectibleType[CollectibleType["BONE_SPURS"] = 683] = "BONE_SPURS";
    CollectibleType[CollectibleType["HUNGRY_SOUL"] = 684] = "HUNGRY_SOUL";
    CollectibleType[CollectibleType["JAR_OF_WISPS"] = 685] = "JAR_OF_WISPS";
    CollectibleType[CollectibleType["SOUL_LOCKET"] = 686] = "SOUL_LOCKET";
    CollectibleType[CollectibleType["FRIEND_FINDER"] = 687] = "FRIEND_FINDER";
    CollectibleType[CollectibleType["INNER_CHILD"] = 688] = "INNER_CHILD";
    CollectibleType[CollectibleType["GLITCHED_CROWN"] = 689] = "GLITCHED_CROWN";
    CollectibleType[CollectibleType["JELLY_BELLY"] = 690] = "JELLY_BELLY";
    CollectibleType[CollectibleType["SACRED_ORB"] = 691] = "SACRED_ORB";
    CollectibleType[CollectibleType["SANGUINE_BOND"] = 692] = "SANGUINE_BOND";
    CollectibleType[CollectibleType["SWARM"] = 693] = "SWARM";
    CollectibleType[CollectibleType["HEARTBREAK"] = 694] = "HEARTBREAK";
    CollectibleType[CollectibleType["BLOODY_GUST"] = 695] = "BLOODY_GUST";
    CollectibleType[CollectibleType["SALVATION"] = 696] = "SALVATION";
    CollectibleType[CollectibleType["VANISHING_TWIN"] = 697] = "VANISHING_TWIN";
    CollectibleType[CollectibleType["TWISTED_PAIR"] = 698] = "TWISTED_PAIR";
    CollectibleType[CollectibleType["AZAZELS_RAGE"] = 699] = "AZAZELS_RAGE";
    CollectibleType[CollectibleType["ECHO_CHAMBER"] = 700] = "ECHO_CHAMBER";
    CollectibleType[CollectibleType["ISAACS_TOMB"] = 701] = "ISAACS_TOMB";
    CollectibleType[CollectibleType["VENGEFUL_SPIRIT"] = 702] = "VENGEFUL_SPIRIT";
    CollectibleType[CollectibleType["ESAU_JR"] = 703] = "ESAU_JR";
    CollectibleType[CollectibleType["BERSERK"] = 704] = "BERSERK";
    CollectibleType[CollectibleType["DARK_ARTS"] = 705] = "DARK_ARTS";
    CollectibleType[CollectibleType["ABYSS"] = 706] = "ABYSS";
    CollectibleType[CollectibleType["SUPPER"] = 707] = "SUPPER";
    CollectibleType[CollectibleType["STAPLER"] = 708] = "STAPLER";
    CollectibleType[CollectibleType["SUPLEX"] = 709] = "SUPLEX";
    CollectibleType[CollectibleType["BAG_OF_CRAFTING"] = 710] = "BAG_OF_CRAFTING";
    CollectibleType[CollectibleType["FLIP"] = 711] = "FLIP";
    CollectibleType[CollectibleType["LEMEGETON"] = 712] = "LEMEGETON";
    CollectibleType[CollectibleType["SUMPTORIUM"] = 713] = "SUMPTORIUM";
    CollectibleType[CollectibleType["RECALL"] = 714] = "RECALL";
    CollectibleType[CollectibleType["HOLD"] = 715] = "HOLD";
    CollectibleType[CollectibleType["KEEPERS_SACK"] = 716] = "KEEPERS_SACK";
    CollectibleType[CollectibleType["KEEPERS_KIN"] = 717] = "KEEPERS_KIN";
    // - There is no enum member with a value of 718.
    CollectibleType[CollectibleType["KEEPERS_BOX"] = 719] = "KEEPERS_BOX";
    CollectibleType[CollectibleType["EVERYTHING_JAR"] = 720] = "EVERYTHING_JAR";
    CollectibleType[CollectibleType["TMTRAINER"] = 721] = "TMTRAINER";
    CollectibleType[CollectibleType["ANIMA_SOLA"] = 722] = "ANIMA_SOLA";
    CollectibleType[CollectibleType["SPINDOWN_DICE"] = 723] = "SPINDOWN_DICE";
    CollectibleType[CollectibleType["HYPERCOAGULATION"] = 724] = "HYPERCOAGULATION";
    CollectibleType[CollectibleType["IBS"] = 725] = "IBS";
    CollectibleType[CollectibleType["HEMOPTYSIS"] = 726] = "HEMOPTYSIS";
    CollectibleType[CollectibleType["GHOST_BOMBS"] = 727] = "GHOST_BOMBS";
    CollectibleType[CollectibleType["GELLO"] = 728] = "GELLO";
    CollectibleType[CollectibleType["DECAP_ATTACK"] = 729] = "DECAP_ATTACK";
    CollectibleType[CollectibleType["GLASS_EYE"] = 730] = "GLASS_EYE";
    CollectibleType[CollectibleType["STYE"] = 731] = "STYE";
    CollectibleType[CollectibleType["MOMS_RING"] = 732] = "MOMS_RING";
})(CollectibleType || (exports.CollectibleType = CollectibleType = {}));
/**
 * For `EntityType.PICKUP` (5), `PickupVariant.CARD` (300).
 *
 * This is the sub-type of a card.
 *
 * This enum was renamed from "Card" to be consistent with the `CollectibleType` and `TrinketType`
 * enums.
 *
 * This enum is contiguous. (Every value is satisfied between 0 and 97, inclusive.)
 */
var CardType;
(function (CardType) {
    /**
     * Spawning cards with this sub-type will produce a random card with the following probabilities:
     *
     * - Random tarot card (1-22) - 66.66%
     * - Specific tarot card (1-22) - 3.03%
     * - Random face card (23-31) - 7.74%
     * - Specific face card (23-31) - 0.86%
     * - Random rune (32-41) - 3.60%
     * - Specific rune (32-41) - 0.36%
     * - Random special card (42-54) - 3.51%
     * - Specific special card (42-54) - 0.27%
     * - Rune shard (55) - 0.00% (never spawns, assuming a fully unlocked save file)
     * - Random reverse tarot card (56-77) - 11.22%
     * - Specific reverse tarot card (56-77) - 0.51%
     * - Cracked Key (78) - 0.27% (same as special card)
     * - Queen of Hearts (79) - 0.86% (same as face card)
     * - Wild Card (80) - 0.27% (same as special card)
     * - Random character rune (81-97) - 5.95%
     * - Specific character rune (81-97) - 0.35%
     */
    CardType[CardType["NULL"] = 0] = "NULL";
    CardType[CardType["FOOL"] = 1] = "FOOL";
    CardType[CardType["MAGICIAN"] = 2] = "MAGICIAN";
    CardType[CardType["HIGH_PRIESTESS"] = 3] = "HIGH_PRIESTESS";
    CardType[CardType["EMPRESS"] = 4] = "EMPRESS";
    CardType[CardType["EMPEROR"] = 5] = "EMPEROR";
    CardType[CardType["HIEROPHANT"] = 6] = "HIEROPHANT";
    CardType[CardType["LOVERS"] = 7] = "LOVERS";
    CardType[CardType["CHARIOT"] = 8] = "CHARIOT";
    CardType[CardType["JUSTICE"] = 9] = "JUSTICE";
    CardType[CardType["HERMIT"] = 10] = "HERMIT";
    CardType[CardType["WHEEL_OF_FORTUNE"] = 11] = "WHEEL_OF_FORTUNE";
    CardType[CardType["STRENGTH"] = 12] = "STRENGTH";
    CardType[CardType["HANGED_MAN"] = 13] = "HANGED_MAN";
    CardType[CardType["DEATH"] = 14] = "DEATH";
    CardType[CardType["TEMPERANCE"] = 15] = "TEMPERANCE";
    CardType[CardType["DEVIL"] = 16] = "DEVIL";
    CardType[CardType["TOWER"] = 17] = "TOWER";
    CardType[CardType["STARS"] = 18] = "STARS";
    CardType[CardType["MOON"] = 19] = "MOON";
    CardType[CardType["SUN"] = 20] = "SUN";
    CardType[CardType["JUDGEMENT"] = 21] = "JUDGEMENT";
    CardType[CardType["WORLD"] = 22] = "WORLD";
    CardType[CardType["TWO_OF_CLUBS"] = 23] = "TWO_OF_CLUBS";
    CardType[CardType["TWO_OF_DIAMONDS"] = 24] = "TWO_OF_DIAMONDS";
    CardType[CardType["TWO_OF_SPADES"] = 25] = "TWO_OF_SPADES";
    CardType[CardType["TWO_OF_HEARTS"] = 26] = "TWO_OF_HEARTS";
    CardType[CardType["ACE_OF_CLUBS"] = 27] = "ACE_OF_CLUBS";
    CardType[CardType["ACE_OF_DIAMONDS"] = 28] = "ACE_OF_DIAMONDS";
    CardType[CardType["ACE_OF_SPADES"] = 29] = "ACE_OF_SPADES";
    CardType[CardType["ACE_OF_HEARTS"] = 30] = "ACE_OF_HEARTS";
    CardType[CardType["JOKER"] = 31] = "JOKER";
    CardType[CardType["RUNE_HAGALAZ"] = 32] = "RUNE_HAGALAZ";
    CardType[CardType["RUNE_JERA"] = 33] = "RUNE_JERA";
    CardType[CardType["RUNE_EHWAZ"] = 34] = "RUNE_EHWAZ";
    CardType[CardType["RUNE_DAGAZ"] = 35] = "RUNE_DAGAZ";
    CardType[CardType["RUNE_ANSUZ"] = 36] = "RUNE_ANSUZ";
    CardType[CardType["RUNE_PERTHRO"] = 37] = "RUNE_PERTHRO";
    CardType[CardType["RUNE_BERKANO"] = 38] = "RUNE_BERKANO";
    CardType[CardType["RUNE_ALGIZ"] = 39] = "RUNE_ALGIZ";
    CardType[CardType["RUNE_BLANK"] = 40] = "RUNE_BLANK";
    CardType[CardType["RUNE_BLACK"] = 41] = "RUNE_BLACK";
    CardType[CardType["CHAOS"] = 42] = "CHAOS";
    CardType[CardType["CREDIT"] = 43] = "CREDIT";
    CardType[CardType["RULES"] = 44] = "RULES";
    CardType[CardType["AGAINST_HUMANITY"] = 45] = "AGAINST_HUMANITY";
    CardType[CardType["SUICIDE_KING"] = 46] = "SUICIDE_KING";
    CardType[CardType["GET_OUT_OF_JAIL_FREE"] = 47] = "GET_OUT_OF_JAIL_FREE";
    CardType[CardType["QUESTION_MARK"] = 48] = "QUESTION_MARK";
    CardType[CardType["DICE_SHARD"] = 49] = "DICE_SHARD";
    CardType[CardType["EMERGENCY_CONTACT"] = 50] = "EMERGENCY_CONTACT";
    CardType[CardType["HOLY"] = 51] = "HOLY";
    CardType[CardType["HUGE_GROWTH"] = 52] = "HUGE_GROWTH";
    CardType[CardType["ANCIENT_RECALL"] = 53] = "ANCIENT_RECALL";
    CardType[CardType["ERA_WALK"] = 54] = "ERA_WALK";
    CardType[CardType["RUNE_SHARD"] = 55] = "RUNE_SHARD";
    CardType[CardType["REVERSE_FOOL"] = 56] = "REVERSE_FOOL";
    CardType[CardType["REVERSE_MAGICIAN"] = 57] = "REVERSE_MAGICIAN";
    CardType[CardType["REVERSE_HIGH_PRIESTESS"] = 58] = "REVERSE_HIGH_PRIESTESS";
    CardType[CardType["REVERSE_EMPRESS"] = 59] = "REVERSE_EMPRESS";
    CardType[CardType["REVERSE_EMPEROR"] = 60] = "REVERSE_EMPEROR";
    CardType[CardType["REVERSE_HIEROPHANT"] = 61] = "REVERSE_HIEROPHANT";
    CardType[CardType["REVERSE_LOVERS"] = 62] = "REVERSE_LOVERS";
    CardType[CardType["REVERSE_CHARIOT"] = 63] = "REVERSE_CHARIOT";
    CardType[CardType["REVERSE_JUSTICE"] = 64] = "REVERSE_JUSTICE";
    CardType[CardType["REVERSE_HERMIT"] = 65] = "REVERSE_HERMIT";
    CardType[CardType["REVERSE_WHEEL_OF_FORTUNE"] = 66] = "REVERSE_WHEEL_OF_FORTUNE";
    CardType[CardType["REVERSE_STRENGTH"] = 67] = "REVERSE_STRENGTH";
    CardType[CardType["REVERSE_HANGED_MAN"] = 68] = "REVERSE_HANGED_MAN";
    CardType[CardType["REVERSE_DEATH"] = 69] = "REVERSE_DEATH";
    CardType[CardType["REVERSE_TEMPERANCE"] = 70] = "REVERSE_TEMPERANCE";
    CardType[CardType["REVERSE_DEVIL"] = 71] = "REVERSE_DEVIL";
    CardType[CardType["REVERSE_TOWER"] = 72] = "REVERSE_TOWER";
    CardType[CardType["REVERSE_STARS"] = 73] = "REVERSE_STARS";
    CardType[CardType["REVERSE_MOON"] = 74] = "REVERSE_MOON";
    CardType[CardType["REVERSE_SUN"] = 75] = "REVERSE_SUN";
    CardType[CardType["REVERSE_JUDGEMENT"] = 76] = "REVERSE_JUDGEMENT";
    CardType[CardType["REVERSE_WORLD"] = 77] = "REVERSE_WORLD";
    CardType[CardType["CRACKED_KEY"] = 78] = "CRACKED_KEY";
    CardType[CardType["QUEEN_OF_HEARTS"] = 79] = "QUEEN_OF_HEARTS";
    CardType[CardType["WILD"] = 80] = "WILD";
    CardType[CardType["SOUL_OF_ISAAC"] = 81] = "SOUL_OF_ISAAC";
    CardType[CardType["SOUL_OF_MAGDALENE"] = 82] = "SOUL_OF_MAGDALENE";
    CardType[CardType["SOUL_OF_CAIN"] = 83] = "SOUL_OF_CAIN";
    CardType[CardType["SOUL_OF_JUDAS"] = 84] = "SOUL_OF_JUDAS";
    CardType[CardType["SOUL_OF_BLUE_BABY"] = 85] = "SOUL_OF_BLUE_BABY";
    CardType[CardType["SOUL_OF_EVE"] = 86] = "SOUL_OF_EVE";
    CardType[CardType["SOUL_OF_SAMSON"] = 87] = "SOUL_OF_SAMSON";
    CardType[CardType["SOUL_OF_AZAZEL"] = 88] = "SOUL_OF_AZAZEL";
    CardType[CardType["SOUL_OF_LAZARUS"] = 89] = "SOUL_OF_LAZARUS";
    CardType[CardType["SOUL_OF_EDEN"] = 90] = "SOUL_OF_EDEN";
    CardType[CardType["SOUL_OF_LOST"] = 91] = "SOUL_OF_LOST";
    CardType[CardType["SOUL_OF_LILITH"] = 92] = "SOUL_OF_LILITH";
    CardType[CardType["SOUL_OF_KEEPER"] = 93] = "SOUL_OF_KEEPER";
    CardType[CardType["SOUL_OF_APOLLYON"] = 94] = "SOUL_OF_APOLLYON";
    CardType[CardType["SOUL_OF_FORGOTTEN"] = 95] = "SOUL_OF_FORGOTTEN";
    CardType[CardType["SOUL_OF_BETHANY"] = 96] = "SOUL_OF_BETHANY";
    CardType[CardType["SOUL_OF_JACOB_AND_ESAU"] = 97] = "SOUL_OF_JACOB_AND_ESAU";
})(CardType || (exports.CardType = CardType = {}));
/**
 * For `EntityType.PICKUP` (5), `PickupVariant.TRINKET` (350).
 *
 * This is the sub-type of a trinket.
 *
 * This enum is not contiguous. In other words, the enum ranges from `TrinketType.NULL` (0) to
 * `TrinketType.SIGIL_OF_BAPHOMET` (189), but there is no corresponding `TrinketType` with a value
 * of 47.
 */
var TrinketType;
(function (TrinketType) {
    /** Spawning trinkets with this sub-type will produce a random trinket. */
    TrinketType[TrinketType["NULL"] = 0] = "NULL";
    TrinketType[TrinketType["SWALLOWED_PENNY"] = 1] = "SWALLOWED_PENNY";
    TrinketType[TrinketType["PETRIFIED_POOP"] = 2] = "PETRIFIED_POOP";
    TrinketType[TrinketType["AAA_BATTERY"] = 3] = "AAA_BATTERY";
    TrinketType[TrinketType["BROKEN_REMOTE"] = 4] = "BROKEN_REMOTE";
    TrinketType[TrinketType["PURPLE_HEART"] = 5] = "PURPLE_HEART";
    TrinketType[TrinketType["BROKEN_MAGNET"] = 6] = "BROKEN_MAGNET";
    TrinketType[TrinketType["ROSARY_BEAD"] = 7] = "ROSARY_BEAD";
    TrinketType[TrinketType["CARTRIDGE"] = 8] = "CARTRIDGE";
    TrinketType[TrinketType["PULSE_WORM"] = 9] = "PULSE_WORM";
    TrinketType[TrinketType["WIGGLE_WORM"] = 10] = "WIGGLE_WORM";
    TrinketType[TrinketType["RING_WORM"] = 11] = "RING_WORM";
    TrinketType[TrinketType["FLAT_WORM"] = 12] = "FLAT_WORM";
    TrinketType[TrinketType["STORE_CREDIT"] = 13] = "STORE_CREDIT";
    TrinketType[TrinketType["CALLUS"] = 14] = "CALLUS";
    TrinketType[TrinketType["LUCKY_ROCK"] = 15] = "LUCKY_ROCK";
    TrinketType[TrinketType["MOMS_TOENAIL"] = 16] = "MOMS_TOENAIL";
    TrinketType[TrinketType["BLACK_LIPSTICK"] = 17] = "BLACK_LIPSTICK";
    TrinketType[TrinketType["BIBLE_TRACT"] = 18] = "BIBLE_TRACT";
    TrinketType[TrinketType["PAPER_CLIP"] = 19] = "PAPER_CLIP";
    TrinketType[TrinketType["MONKEY_PAW"] = 20] = "MONKEY_PAW";
    TrinketType[TrinketType["MYSTERIOUS_PAPER"] = 21] = "MYSTERIOUS_PAPER";
    TrinketType[TrinketType["DAEMONS_TAIL"] = 22] = "DAEMONS_TAIL";
    TrinketType[TrinketType["MISSING_POSTER"] = 23] = "MISSING_POSTER";
    TrinketType[TrinketType["BUTT_PENNY"] = 24] = "BUTT_PENNY";
    TrinketType[TrinketType["MYSTERIOUS_CANDY"] = 25] = "MYSTERIOUS_CANDY";
    TrinketType[TrinketType["HOOK_WORM"] = 26] = "HOOK_WORM";
    TrinketType[TrinketType["WHIP_WORM"] = 27] = "WHIP_WORM";
    TrinketType[TrinketType["BROKEN_ANKH"] = 28] = "BROKEN_ANKH";
    TrinketType[TrinketType["FISH_HEAD"] = 29] = "FISH_HEAD";
    TrinketType[TrinketType["PINKY_EYE"] = 30] = "PINKY_EYE";
    TrinketType[TrinketType["PUSH_PIN"] = 31] = "PUSH_PIN";
    TrinketType[TrinketType["LIBERTY_CAP"] = 32] = "LIBERTY_CAP";
    TrinketType[TrinketType["UMBILICAL_CORD"] = 33] = "UMBILICAL_CORD";
    TrinketType[TrinketType["CHILDS_HEART"] = 34] = "CHILDS_HEART";
    TrinketType[TrinketType["CURVED_HORN"] = 35] = "CURVED_HORN";
    TrinketType[TrinketType["RUSTED_KEY"] = 36] = "RUSTED_KEY";
    TrinketType[TrinketType["GOAT_HOOF"] = 37] = "GOAT_HOOF";
    TrinketType[TrinketType["MOMS_PEARL"] = 38] = "MOMS_PEARL";
    TrinketType[TrinketType["CANCER"] = 39] = "CANCER";
    TrinketType[TrinketType["RED_PATCH"] = 40] = "RED_PATCH";
    TrinketType[TrinketType["MATCH_STICK"] = 41] = "MATCH_STICK";
    TrinketType[TrinketType["LUCKY_TOE"] = 42] = "LUCKY_TOE";
    TrinketType[TrinketType["CURSED_SKULL"] = 43] = "CURSED_SKULL";
    TrinketType[TrinketType["SAFETY_CAP"] = 44] = "SAFETY_CAP";
    TrinketType[TrinketType["ACE_OF_SPADES"] = 45] = "ACE_OF_SPADES";
    TrinketType[TrinketType["ISAACS_FORK"] = 46] = "ISAACS_FORK";
    // - There is no enum member with a value of 47. This was originally the ID for The Polaroid in
    //   Wrath of the Lamb. In the vanilla enums, this is listed as `POLAROID_OBSOLETE`.
    TrinketType[TrinketType["MISSING_PAGE"] = 48] = "MISSING_PAGE";
    TrinketType[TrinketType["BLOODY_PENNY"] = 49] = "BLOODY_PENNY";
    TrinketType[TrinketType["BURNT_PENNY"] = 50] = "BURNT_PENNY";
    TrinketType[TrinketType["FLAT_PENNY"] = 51] = "FLAT_PENNY";
    TrinketType[TrinketType["COUNTERFEIT_PENNY"] = 52] = "COUNTERFEIT_PENNY";
    TrinketType[TrinketType["TICK"] = 53] = "TICK";
    TrinketType[TrinketType["ISAACS_HEAD"] = 54] = "ISAACS_HEAD";
    TrinketType[TrinketType["MAGGYS_FAITH"] = 55] = "MAGGYS_FAITH";
    TrinketType[TrinketType["JUDAS_TONGUE"] = 56] = "JUDAS_TONGUE";
    TrinketType[TrinketType["BLUE_BABYS_SOUL"] = 57] = "BLUE_BABYS_SOUL";
    TrinketType[TrinketType["SAMSONS_LOCK"] = 58] = "SAMSONS_LOCK";
    TrinketType[TrinketType["CAINS_EYE"] = 59] = "CAINS_EYE";
    TrinketType[TrinketType["EVES_BIRD_FOOT"] = 60] = "EVES_BIRD_FOOT";
    TrinketType[TrinketType["LEFT_HAND"] = 61] = "LEFT_HAND";
    TrinketType[TrinketType["SHINY_ROCK"] = 62] = "SHINY_ROCK";
    TrinketType[TrinketType["SAFETY_SCISSORS"] = 63] = "SAFETY_SCISSORS";
    TrinketType[TrinketType["RAINBOW_WORM"] = 64] = "RAINBOW_WORM";
    TrinketType[TrinketType["TAPE_WORM"] = 65] = "TAPE_WORM";
    TrinketType[TrinketType["LAZY_WORM"] = 66] = "LAZY_WORM";
    TrinketType[TrinketType["CRACKED_DICE"] = 67] = "CRACKED_DICE";
    TrinketType[TrinketType["SUPER_MAGNET"] = 68] = "SUPER_MAGNET";
    TrinketType[TrinketType["FADED_POLAROID"] = 69] = "FADED_POLAROID";
    TrinketType[TrinketType["LOUSE"] = 70] = "LOUSE";
    TrinketType[TrinketType["BOBS_BLADDER"] = 71] = "BOBS_BLADDER";
    TrinketType[TrinketType["WATCH_BATTERY"] = 72] = "WATCH_BATTERY";
    TrinketType[TrinketType["BLASTING_CAP"] = 73] = "BLASTING_CAP";
    TrinketType[TrinketType["STUD_FINDER"] = 74] = "STUD_FINDER";
    TrinketType[TrinketType["ERROR"] = 75] = "ERROR";
    TrinketType[TrinketType["POKER_CHIP"] = 76] = "POKER_CHIP";
    TrinketType[TrinketType["BLISTER"] = 77] = "BLISTER";
    TrinketType[TrinketType["SECOND_HAND"] = 78] = "SECOND_HAND";
    TrinketType[TrinketType["ENDLESS_NAMELESS"] = 79] = "ENDLESS_NAMELESS";
    TrinketType[TrinketType["BLACK_FEATHER"] = 80] = "BLACK_FEATHER";
    TrinketType[TrinketType["BLIND_RAGE"] = 81] = "BLIND_RAGE";
    TrinketType[TrinketType["GOLDEN_HORSE_SHOE"] = 82] = "GOLDEN_HORSE_SHOE";
    TrinketType[TrinketType["STORE_KEY"] = 83] = "STORE_KEY";
    TrinketType[TrinketType["RIB_OF_GREED"] = 84] = "RIB_OF_GREED";
    TrinketType[TrinketType["KARMA"] = 85] = "KARMA";
    TrinketType[TrinketType["LIL_LARVA"] = 86] = "LIL_LARVA";
    TrinketType[TrinketType["MOMS_LOCKET"] = 87] = "MOMS_LOCKET";
    TrinketType[TrinketType["NO"] = 88] = "NO";
    TrinketType[TrinketType["CHILD_LEASH"] = 89] = "CHILD_LEASH";
    TrinketType[TrinketType["BROWN_CAP"] = 90] = "BROWN_CAP";
    TrinketType[TrinketType["MECONIUM"] = 91] = "MECONIUM";
    TrinketType[TrinketType["CRACKED_CROWN"] = 92] = "CRACKED_CROWN";
    TrinketType[TrinketType["USED_DIAPER"] = 93] = "USED_DIAPER";
    TrinketType[TrinketType["FISH_TAIL"] = 94] = "FISH_TAIL";
    TrinketType[TrinketType["BLACK_TOOTH"] = 95] = "BLACK_TOOTH";
    TrinketType[TrinketType["OUROBOROS_WORM"] = 96] = "OUROBOROS_WORM";
    TrinketType[TrinketType["TONSIL"] = 97] = "TONSIL";
    TrinketType[TrinketType["NOSE_GOBLIN"] = 98] = "NOSE_GOBLIN";
    TrinketType[TrinketType["SUPER_BALL"] = 99] = "SUPER_BALL";
    TrinketType[TrinketType["VIBRANT_BULB"] = 100] = "VIBRANT_BULB";
    TrinketType[TrinketType["DIM_BULB"] = 101] = "DIM_BULB";
    TrinketType[TrinketType["FRAGMENTED_CARD"] = 102] = "FRAGMENTED_CARD";
    TrinketType[TrinketType["EQUALITY"] = 103] = "EQUALITY";
    TrinketType[TrinketType["WISH_BONE"] = 104] = "WISH_BONE";
    TrinketType[TrinketType["BAG_LUNCH"] = 105] = "BAG_LUNCH";
    TrinketType[TrinketType["LOST_CORK"] = 106] = "LOST_CORK";
    TrinketType[TrinketType["CROW_HEART"] = 107] = "CROW_HEART";
    TrinketType[TrinketType["WALNUT"] = 108] = "WALNUT";
    TrinketType[TrinketType["DUCT_TAPE"] = 109] = "DUCT_TAPE";
    TrinketType[TrinketType["SILVER_DOLLAR"] = 110] = "SILVER_DOLLAR";
    TrinketType[TrinketType["BLOODY_CROWN"] = 111] = "BLOODY_CROWN";
    TrinketType[TrinketType["PAY_TO_WIN"] = 112] = "PAY_TO_WIN";
    TrinketType[TrinketType["LOCUST_OF_WRATH"] = 113] = "LOCUST_OF_WRATH";
    TrinketType[TrinketType["LOCUST_OF_PESTILENCE"] = 114] = "LOCUST_OF_PESTILENCE";
    TrinketType[TrinketType["LOCUST_OF_FAMINE"] = 115] = "LOCUST_OF_FAMINE";
    TrinketType[TrinketType["LOCUST_OF_DEATH"] = 116] = "LOCUST_OF_DEATH";
    TrinketType[TrinketType["LOCUST_OF_CONQUEST"] = 117] = "LOCUST_OF_CONQUEST";
    TrinketType[TrinketType["BAT_WING"] = 118] = "BAT_WING";
    TrinketType[TrinketType["STEM_CELL"] = 119] = "STEM_CELL";
    TrinketType[TrinketType["HAIRPIN"] = 120] = "HAIRPIN";
    TrinketType[TrinketType["WOODEN_CROSS"] = 121] = "WOODEN_CROSS";
    TrinketType[TrinketType["BUTTER"] = 122] = "BUTTER";
    TrinketType[TrinketType["FILIGREE_FEATHERS"] = 123] = "FILIGREE_FEATHERS";
    TrinketType[TrinketType["DOOR_STOP"] = 124] = "DOOR_STOP";
    TrinketType[TrinketType["EXTENSION_CORD"] = 125] = "EXTENSION_CORD";
    TrinketType[TrinketType["ROTTEN_PENNY"] = 126] = "ROTTEN_PENNY";
    TrinketType[TrinketType["BABY_BENDER"] = 127] = "BABY_BENDER";
    TrinketType[TrinketType["FINGER_BONE"] = 128] = "FINGER_BONE";
    TrinketType[TrinketType["JAW_BREAKER"] = 129] = "JAW_BREAKER";
    TrinketType[TrinketType["CHEWED_PEN"] = 130] = "CHEWED_PEN";
    TrinketType[TrinketType["BLESSED_PENNY"] = 131] = "BLESSED_PENNY";
    TrinketType[TrinketType["BROKEN_SYRINGE"] = 132] = "BROKEN_SYRINGE";
    TrinketType[TrinketType["SHORT_FUSE"] = 133] = "SHORT_FUSE";
    TrinketType[TrinketType["GIGANTE_BEAN"] = 134] = "GIGANTE_BEAN";
    TrinketType[TrinketType["LIGHTER"] = 135] = "LIGHTER";
    TrinketType[TrinketType["BROKEN_PADLOCK"] = 136] = "BROKEN_PADLOCK";
    TrinketType[TrinketType["MYOSOTIS"] = 137] = "MYOSOTIS";
    TrinketType[TrinketType["M"] = 138] = "M";
    TrinketType[TrinketType["TEARDROP_CHARM"] = 139] = "TEARDROP_CHARM";
    TrinketType[TrinketType["APPLE_OF_SODOM"] = 140] = "APPLE_OF_SODOM";
    TrinketType[TrinketType["FORGOTTEN_LULLABY"] = 141] = "FORGOTTEN_LULLABY";
    TrinketType[TrinketType["BETHS_FAITH"] = 142] = "BETHS_FAITH";
    TrinketType[TrinketType["OLD_CAPACITOR"] = 143] = "OLD_CAPACITOR";
    TrinketType[TrinketType["BRAIN_WORM"] = 144] = "BRAIN_WORM";
    TrinketType[TrinketType["PERFECTION"] = 145] = "PERFECTION";
    TrinketType[TrinketType["DEVILS_CROWN"] = 146] = "DEVILS_CROWN";
    TrinketType[TrinketType["CHARGED_PENNY"] = 147] = "CHARGED_PENNY";
    TrinketType[TrinketType["FRIENDSHIP_NECKLACE"] = 148] = "FRIENDSHIP_NECKLACE";
    TrinketType[TrinketType["PANIC_BUTTON"] = 149] = "PANIC_BUTTON";
    TrinketType[TrinketType["BLUE_KEY"] = 150] = "BLUE_KEY";
    TrinketType[TrinketType["FLAT_FILE"] = 151] = "FLAT_FILE";
    TrinketType[TrinketType["TELESCOPE_LENS"] = 152] = "TELESCOPE_LENS";
    TrinketType[TrinketType["MOMS_LOCK"] = 153] = "MOMS_LOCK";
    TrinketType[TrinketType["DICE_BAG"] = 154] = "DICE_BAG";
    TrinketType[TrinketType["HOLY_CROWN"] = 155] = "HOLY_CROWN";
    TrinketType[TrinketType["MOTHERS_KISS"] = 156] = "MOTHERS_KISS";
    TrinketType[TrinketType["TORN_CARD"] = 157] = "TORN_CARD";
    TrinketType[TrinketType["TORN_POCKET"] = 158] = "TORN_POCKET";
    TrinketType[TrinketType["GILDED_KEY"] = 159] = "GILDED_KEY";
    TrinketType[TrinketType["LUCKY_SACK"] = 160] = "LUCKY_SACK";
    TrinketType[TrinketType["WICKED_CROWN"] = 161] = "WICKED_CROWN";
    TrinketType[TrinketType["AZAZELS_STUMP"] = 162] = "AZAZELS_STUMP";
    TrinketType[TrinketType["DINGLE_BERRY"] = 163] = "DINGLE_BERRY";
    TrinketType[TrinketType["RING_CAP"] = 164] = "RING_CAP";
    TrinketType[TrinketType["NUH_UH"] = 165] = "NUH_UH";
    TrinketType[TrinketType["MODELING_CLAY"] = 166] = "MODELING_CLAY";
    TrinketType[TrinketType["POLISHED_BONE"] = 167] = "POLISHED_BONE";
    TrinketType[TrinketType["HOLLOW_HEART"] = 168] = "HOLLOW_HEART";
    TrinketType[TrinketType["KIDS_DRAWING"] = 169] = "KIDS_DRAWING";
    TrinketType[TrinketType["CRYSTAL_KEY"] = 170] = "CRYSTAL_KEY";
    TrinketType[TrinketType["KEEPERS_BARGAIN"] = 171] = "KEEPERS_BARGAIN";
    TrinketType[TrinketType["CURSED_PENNY"] = 172] = "CURSED_PENNY";
    TrinketType[TrinketType["YOUR_SOUL"] = 173] = "YOUR_SOUL";
    TrinketType[TrinketType["NUMBER_MAGNET"] = 174] = "NUMBER_MAGNET";
    TrinketType[TrinketType["STRANGE_KEY"] = 175] = "STRANGE_KEY";
    TrinketType[TrinketType["LIL_CLOT"] = 176] = "LIL_CLOT";
    TrinketType[TrinketType["TEMPORARY_TATTOO"] = 177] = "TEMPORARY_TATTOO";
    TrinketType[TrinketType["SWALLOWED_M80"] = 178] = "SWALLOWED_M80";
    TrinketType[TrinketType["RC_REMOTE"] = 179] = "RC_REMOTE";
    TrinketType[TrinketType["FOUND_SOUL"] = 180] = "FOUND_SOUL";
    TrinketType[TrinketType["EXPANSION_PACK"] = 181] = "EXPANSION_PACK";
    TrinketType[TrinketType["BETHS_ESSENCE"] = 182] = "BETHS_ESSENCE";
    TrinketType[TrinketType["TWINS"] = 183] = "TWINS";
    TrinketType[TrinketType["ADOPTION_PAPERS"] = 184] = "ADOPTION_PAPERS";
    TrinketType[TrinketType["CRICKET_LEG"] = 185] = "CRICKET_LEG";
    TrinketType[TrinketType["APOLLYONS_BEST_FRIEND"] = 186] = "APOLLYONS_BEST_FRIEND";
    TrinketType[TrinketType["BROKEN_GLASSES"] = 187] = "BROKEN_GLASSES";
    TrinketType[TrinketType["ICE_CUBE"] = 188] = "ICE_CUBE";
    TrinketType[TrinketType["SIGIL_OF_BAPHOMET"] = 189] = "SIGIL_OF_BAPHOMET";
})(TrinketType || (exports.TrinketType = TrinketType = {}));
/** For `EntityType.PICKUP` (5), `PickupVariant.BED` (380). */
var BedSubType;
(function (BedSubType) {
    BedSubType[BedSubType["ISAAC"] = 0] = "ISAAC";
    BedSubType[BedSubType["MOM"] = 10] = "MOM";
})(BedSubType || (exports.BedSubType = BedSubType = {}));
/** For `EntityType.LASER` (7). */
var LaserSubType;
(function (LaserSubType) {
    /** A typical laser that has a start and end point. */
    LaserSubType[LaserSubType["LINEAR"] = 0] = "LINEAR";
    /** A controlled ring laser (e.g. Tech + Ludovico, Brim + Ludovico). */
    LaserSubType[LaserSubType["RING_LUDOVICO"] = 1] = "RING_LUDOVICO";
    /** A ring laser that travels like a projectile (e.g. Tech X). */
    LaserSubType[LaserSubType["RING_PROJECTILE"] = 2] = "RING_PROJECTILE";
    /** A ring laser that encircle their parents (e.g. Maw of the Void). */
    LaserSubType[LaserSubType["RING_FOLLOW_PARENT"] = 3] = "RING_FOLLOW_PARENT";
    /** For Technology Zero; doesn't create an impact. */
    LaserSubType[LaserSubType["NO_IMPACT"] = 4] = "NO_IMPACT";
})(LaserSubType || (exports.LaserSubType = LaserSubType = {}));
/** For `EntityType.LARRY_JR` (19), `LarryJrVariant.LARRY_JR` (0). */
var LarryJrSubType;
(function (LarryJrSubType) {
    /** The non-champion version. */
    LarryJrSubType[LarryJrSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The green champion version. Will occasionally shoot a projectile in the direction he's facing,
     * pausing momentarily as he does so.
     */
    LarryJrSubType[LarryJrSubType["GREEN"] = 1] = "GREEN";
    /**
     * The blue champion version. Is 15% larger and has 45% more HP, but moves more slowly and does
     * not leave poop behind. Has shared health between his body segments, meaning that dealing damage
     * to one segment will deal a percentage of the damage to the other segments. This version always
     * drops a Soul Heart when defeated.
     */
    LarryJrSubType[LarryJrSubType["BLUE"] = 2] = "BLUE";
})(LarryJrSubType || (exports.LarryJrSubType = LarryJrSubType = {}));
/** For `EntityType.LARRY_JR` (19), `LarryJrVariant.HOLLOW` (1). */
var HollowSubType;
(function (HollowSubType) {
    /** The non-champion version. */
    HollowSubType[HollowSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The green champion version. Has a chance for each segment that isn't the head to spawn a
     * Charger on death. Occasionally stops movement to shoot 3 bullets at wherever it is facing. The
     * head will spawn a Charger only if killed immediately after spawning.
     */
    HollowSubType[HollowSubType["GREEN"] = 1] = "GREEN";
    /**
     * The black champion version. 15% larger, has slower movement and 25% more HP. Each segment that
     * isn't the head spawns a Boom Fly when killed. Does not spawn any poop. The head will spawn a
     * Boom Fly only if killed immediately after spawning.
     */
    HollowSubType[HollowSubType["BLACK"] = 2] = "BLACK";
    /**
     * The yellow champion version. 15% larger and has 25% more HP but retains the same movement
     * speed. Each segment that isn't the head will drop a penny on death. The head will drop a penny
     * only if killed immediately after spawning.
     */
    HollowSubType[HollowSubType["YELLOW"] = 3] = "YELLOW";
})(HollowSubType || (exports.HollowSubType = HollowSubType = {}));
/** For `EntityType.MONSTRO` (20), variant 0. */
var MonstroSubType;
(function (MonstroSubType) {
    /** The non-champion version. */
    MonstroSubType[MonstroSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. Two 20% smaller Monstros replace the normal Monstro, each with 55%
     * less HP than the original.
     */
    MonstroSubType[MonstroSubType["RED"] = 1] = "RED";
    /**
     * The grey champion version. 15% larger and has 25% more HP. Uses projectile volleys much more
     * often and is unable to jump off-screen.
     */
    MonstroSubType[MonstroSubType["GREY"] = 2] = "GREY";
})(MonstroSubType || (exports.MonstroSubType = MonstroSubType = {}));
/** For `EntityType.CHARGER` (23), `ChargerVariant.CHARGER` (0). */
var ChargerSubType;
(function (ChargerSubType) {
    ChargerSubType[ChargerSubType["CHARGER"] = 0] = "CHARGER";
    ChargerSubType[ChargerSubType["MY_SHADOW"] = 1] = "MY_SHADOW";
})(ChargerSubType || (exports.ChargerSubType = ChargerSubType = {}));
/** For `EntityType.CHUB` (28), `ChubVariant.CHUB (0)`. */
var ChubSubType;
(function (ChubSubType) {
    /** The non-champion version. */
    ChubSubType[ChubSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The blue champion version. 15% larger and slower than normal, with 25% more HP. Spawns orange
     * Boils instead of Chargers. Despite the different color, they behave exactly like normal Boils.
     *
     * Note that this actually looks green in-game, but internally it is labeled as blue. (Yellow
     * mixes with blue to cause green.)
     */
    ChubSubType[ChubSubType["BLUE"] = 1] = "BLUE";
    /**
     * The orange champion version. 15% smaller and faster than normal, with 15% less HP. Spawns
     * Spitties instead of Chargers.
     */
    ChubSubType[ChubSubType["ORANGE"] = 2] = "ORANGE";
})(ChubSubType || (exports.ChubSubType = ChubSubType = {}));
/** For `EntityType.CHUB` (28), `ChubVariant.CARRION_QUEEN (2)`. */
var CarrionQueenSubType;
(function (CarrionQueenSubType) {
    /** The non-champion version. */
    CarrionQueenSubType[CarrionQueenSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The pink champion version. Moves slightly quicker, has 100% more HP and spawns small Mask
     * Hearts instead of Red Poop. The hearts have 28 HP and killing them deals 40 damage to Carrion
     * Queen. She does not bounce diagonally around the room when below half health.
     */
    CarrionQueenSubType[CarrionQueenSubType["PINK"] = 1] = "PINK";
})(CarrionQueenSubType || (exports.CarrionQueenSubType = CarrionQueenSubType = {}));
/** For `EntityType.GURDY` (36), variant 0. */
var GurdySubType;
(function (GurdySubType) {
    /** The non-champion version. */
    GurdySubType[GurdySubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The green champion version. 11% larger and does not use her projectile attack. Instead, she
     * summons monsters at a faster rate.
     */
    GurdySubType[GurdySubType["GREEN"] = 1] = "GREEN";
})(GurdySubType || (exports.GurdySubType = GurdySubType = {}));
/** For `EntityType.MONSTRO_2` (43), `Monstro2Variant.MONSTRO_2` (0). */
var Monstro2SubType;
(function (Monstro2SubType) {
    /** The non-champion version. */
    Monstro2SubType[Monstro2SubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. 20% smaller. Moves and attacks much faster, but only spawns 2 Suckers
     * when landing. Has reduced health.
     */
    Monstro2SubType[Monstro2SubType["RED"] = 1] = "RED";
})(Monstro2SubType || (exports.Monstro2SubType = Monstro2SubType = {}));
/** For `EntityType.MOM` (43), `MomVariant.MOM` (0). */
var MomSubType;
(function (MomSubType) {
    /** The non-champion version. */
    MomSubType[MomSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The blue champion version. Has 23% more HP, summons monsters more often, and summons a
     * different variation of enemies that were added in the Wrath of The Lamb expansion of the
     * original game.
     */
    MomSubType[MomSubType["BLUE"] = 1] = "BLUE";
    /**
     * The red champion version. Does not summon monsters at all, and instead repeatedly uses her foot
     * stomp, which has increased speed.
     */
    MomSubType[MomSubType["RED"] = 2] = "RED";
})(MomSubType || (exports.MomSubType = MomSubType = {}));
/** For `EntityType.PIN` (62), `PinVariant.PIN` (0). */
var PinSubType;
(function (PinSubType) {
    /** The non-champion version. */
    PinSubType[PinSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The grey champion version. 15% larger with 25% more HP. Fires a radial burst of 6 spiraling
     * projectiles instead of an explosive projectile and fires 6 projectiles instead of 4 when
     * jumping.
     */
    PinSubType[PinSubType["GREY"] = 1] = "GREY";
})(PinSubType || (exports.PinSubType = PinSubType = {}));
/** For `EntityType.PIN` (62), `PinVariant.FRAIL` (2). */
var FrailSubType;
(function (FrailSubType) {
    /** The non-champion version. */
    FrailSubType[FrailSubType["NORMAL"] = 0] = "NORMAL";
    /** The black champion version. Starts in its second phase, with only 66.6% HP total. */
    FrailSubType[FrailSubType["BLACK"] = 1] = "BLACK";
})(FrailSubType || (exports.FrailSubType = FrailSubType = {}));
/** For `EntityType.FAMINE` (63), variant 0. */
var FamineSubType;
(function (FamineSubType) {
    /** The non-champion version. */
    FamineSubType[FamineSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The blue champion version. Charges more often and veers towards Isaac (similar to the Dark
     * One). He can do this attack regardless of whether Isaac is to his sides. He will shoot six
     * bullets in all directions instead of summoning Pooters. In phase 2, he will spit out a cluster
     * of bullets instead of a triple shot, similar to Monstro's attack, with a lower shot speed than
     * his non-champion version. Will always drop a Soul Heart upon death.
     */
    FamineSubType[FamineSubType["BLUE"] = 1] = "BLUE";
})(FamineSubType || (exports.FamineSubType = FamineSubType = {}));
/** For `EntityType.PESTILENCE` (64), variant 0. */
var PestilenceSubType;
(function (PestilenceSubType) {
    /** The non-champion version. */
    PestilenceSubType[PestilenceSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The grey champion version. Leaves a trail of slowing white creep instead of green creep, shoots
     * 6 projectiles in all directions instead of an Ipecac shot, and spawns Trites instead of
     * Chargers or Spitties. He cannot spawn more than 3 Trites at once. It spawns spiders instead of
     * Attack Flies in phase 2.
     */
    PestilenceSubType[PestilenceSubType["GREY"] = 1] = "GREY";
})(PestilenceSubType || (exports.PestilenceSubType = PestilenceSubType = {}));
/** For `EntityType.WAR` (65), `WarVariant.WAR` (0). */
var WarSubType;
(function (WarSubType) {
    /** The non-champion version. */
    WarSubType[WarSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The grey champion version. 15% larger with 25% more HP. Summons 2 Mega Troll Bombs when he
     * ascends off-screen and summons a single Troll Bomb behind his path when he charges through the
     * screen. When transforming into his second phase, he shoots 6 projectiles in all directions, as
     * well as each time he stops chasing Isaac in this phase.
     */
    WarSubType[WarSubType["GREY"] = 1] = "GREY";
})(WarSubType || (exports.WarSubType = WarSubType = {}));
/** For `EntityType.DEATH` (66), variant 0. */
var DeathSubType;
(function (DeathSubType) {
    /** The non-champion version. */
    DeathSubType[DeathSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The black champion version. 15% larger with 25% more HP. In his first phase, he summons
     * Kamikaze Leeches instead of homing Death Scythes and does not use the Hourglass. He spawns Red
     * Maws rather than Knights after he dismounts from his horse.
     */
    DeathSubType[DeathSubType["BLACK"] = 1] = "BLACK";
})(DeathSubType || (exports.DeathSubType = DeathSubType = {}));
/** For `EntityType.DUKE_OF_FLIES` (67), variant `DukeOfFliesVariant.DUKE_OF_FLIES` (0). */
var DukeOfFliesSubType;
(function (DukeOfFliesSubType) {
    /** The non-champion version. */
    DukeOfFliesSubType[DukeOfFliesSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The green champion version. Spawns Moters instead of the large Attack Flies and shoots blood
     * shots in eight directions when spreading the orbiting flies. He can spread the Attack Flies at
     * any moment instead of only performing it when having enough of them orbiting him, similar to
     * The Husk.
     */
    DukeOfFliesSubType[DukeOfFliesSubType["GREEN"] = 1] = "GREEN";
    /**
     * The orange champion version. 15% larger than normal with 25% more HP and spawns Suckers instead
     * of the large Attack Flies.
     */
    DukeOfFliesSubType[DukeOfFliesSubType["ORANGE"] = 2] = "ORANGE";
})(DukeOfFliesSubType || (exports.DukeOfFliesSubType = DukeOfFliesSubType = {}));
/** For `EntityType.DUKE_OF_FLIES` (67), variant `DukeOfFliesVariant.HUSK` (1). */
var HuskSubType;
(function (HuskSubType) {
    /** The non-champion version. */
    HuskSubType[HuskSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The black champion version. 15% larger with 56% more HP. It moves slower and spawns Boom Flies
     * instead of spiders and Attack Flies. The explosions from the Boom Flies can damage the Husk.
     * Spawns 1-2 additional Boom Flies upon death.
     */
    HuskSubType[HuskSubType["BLACK"] = 1] = "BLACK";
    /**
     * The red champion version. 25% smaller and faster. Rather than spawning enemies, it only fires
     * its ring of eight blood shots. Spawns 1-2 additional Red Boom Flies upon death.
     */
    HuskSubType[HuskSubType["RED"] = 2] = "RED";
})(HuskSubType || (exports.HuskSubType = HuskSubType = {}));
/** For `EntityType.PEEP` (68), variant `PeepVariant.PEEP` (0). */
var PeepSubType;
(function (PeepSubType) {
    /** The non-champion version. */
    PeepSubType[PeepSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The yellow champion version. 15% smaller, moves faster, and leaves a constant trail of yellow
     * creep.
     */
    PeepSubType[PeepSubType["YELLOW"] = 1] = "YELLOW";
    /**
     * The cyan champion version. Starts the battle with both his eyes popped out, similar to The
     * Bloat.
     */
    PeepSubType[PeepSubType["CYAN"] = 2] = "CYAN";
})(PeepSubType || (exports.PeepSubType = PeepSubType = {}));
/** For `EntityType.PEEP` (68), variant `PeepVariant.BLOAT` (1). */
var BloatSubType;
(function (BloatSubType) {
    /** The non-champion version. */
    BloatSubType[BloatSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The green champion version. Fires Spawns 2 Chargers whenever he creates large puddles of creep.
     * Creates green creep instead of red creep.
     */
    BloatSubType[BloatSubType["GREEN"] = 1] = "GREEN";
})(BloatSubType || (exports.BloatSubType = BloatSubType = {}));
/**
 * For `EntityType.FISTULA_BIG` (71), `EntityType.FISTULA_MEDIUM` (72), and
 * `EntityType.FISTULA_SMALL` (73). (All use variant `FistulaVariant.FISTULA` (0).
 */
var FistulaSubType;
(function (FistulaSubType) {
    /** The non-champion version. */
    FistulaSubType[FistulaSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The grey champion version. 15% larger with 25% more HP. Spawns Boom Flies with 15 HP instead of
     * Chargers. Each piece travels much slower and splits into three medium Fistulas as opposed to
     * the original's four, similar to Teratoma.
     */
    FistulaSubType[FistulaSubType["GREY"] = 1] = "GREY";
})(FistulaSubType || (exports.FistulaSubType = FistulaSubType = {}));
/** For `EntityType.GEMINI` (79), variant `GeminiVariant.GEMINI` (0). */
var GeminiSubType;
(function (GeminiSubType) {
    /** The non-champion version. */
    GeminiSubType[GeminiSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The green champion version. They start separated from each other and have no difference in
     * behavior. However, if Contusion is killed last, it will usually drop a Red Heart or Half Red
     * Heart, but will rarely drop any other type of Heart instead (Soul, Bone, Gold, etc).
     */
    GeminiSubType[GeminiSubType["GREEN"] = 1] = "GREEN";
    /**
     * The blue champion version. Suture shoots homing shots. Contusion will drop a Soul Heart if
     * killed last.
     */
    GeminiSubType[GeminiSubType["BLUE"] = 2] = "BLUE";
})(GeminiSubType || (exports.GeminiSubType = GeminiSubType = {}));
/** For `EntityType.GURDY_JR` (99), variant 0. */
var GurdyJrSubType;
(function (GurdyJrSubType) {
    /** The non-champion version. */
    GurdyJrSubType[GurdyJrSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The blue champion version. Instead of one Gurdy Jr., there will be two 42% smaller ones. This
     * version has 45% less HP than the original and only uses the charging attack. It drops a Soul
     * Heart upon death.
     */
    GurdyJrSubType[GurdyJrSubType["BLUE"] = 1] = "BLUE";
    /**
     * The yellow champion version. 15% larger than the regular, with 25% more HP. She spawns Super
     * Pooters instead of regular Pooters. Does not shoot projectiles of any sort.
     */
    GurdyJrSubType[GurdyJrSubType["YELLOW"] = 2] = "YELLOW";
})(GurdyJrSubType || (exports.GurdyJrSubType = GurdyJrSubType = {}));
/** For `EntityType.WIDOW` (100), `WidowVariant.WIDOW` (0). */
var WidowSubType;
(function (WidowSubType) {
    /** The non-champion version. */
    WidowSubType[WidowSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The black champion version. Spawns Big Spiders with half health instead of Sacks, black creep
     * instead of white, and spits out six blood shots instead of spiders.
     */
    WidowSubType[WidowSubType["BLACK"] = 1] = "BLACK";
    /**
     * The pink champion version. Spawns Boils instead of Sacks and Attack Flies instead of spiders.
     * Jumps quicker. She is also 25% smaller and has 10% less health.
     */
    WidowSubType[WidowSubType["PINK"] = 2] = "PINK";
})(WidowSubType || (exports.WidowSubType = WidowSubType = {}));
/** For `EntityType.GURGLING` (100), `GurglingVariant.GURGLING_BOSS` (1). */
var GurglingSubType;
(function (GurglingSubType) {
    /** The non-champion version. */
    GurglingSubType[GurglingSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The yellow champion version. Three Gurglings will appear instead of two. They are faster but do
     * not leave any creep. They don't spawn any Attack Flies.
     */
    GurglingSubType[GurglingSubType["YELLOW"] = 1] = "YELLOW";
    /**
     * The black champion version. Gurglings spawn Troll Bombs at regular intervals instead of red
     * creep when rushing towards the player. They take only 5 damage from their own bombs. They don't
     * spawn any Attack Flies.
     */
    GurglingSubType[GurglingSubType["BLACK"] = 2] = "BLACK";
})(GurglingSubType || (exports.GurglingSubType = GurglingSubType = {}));
/** For `EntityType.HAUNT` (260), `HauntVariant.HAUNT` (0). */
var HauntSubType;
(function (HauntSubType) {
    /** The non-champion version. */
    HauntSubType[HauntSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The black champion version. Only two Lil' Haunts circle The Haunt in the first phase. In the
     * second phase, The Haunt spawns 1-2 spiders instead of firing a brimstone laser.
     */
    HauntSubType[HauntSubType["BLACK"] = 1] = "BLACK";
    /**
     * The pink champion version. Only one Lil' Haunt circles The Haunt in the first phase. In the
     * second phase, The Haunt has 50% less HP (100). The Haunt's laser is replaced with two diagonal
     * Brimstone lasers that reflect once off of walls. The Haunt's blood-shot attack is changed to 8
     * shots and is aimed towards Isaac.
     */
    HauntSubType[HauntSubType["PINK"] = 2] = "PINK";
})(HauntSubType || (exports.HauntSubType = HauntSubType = {}));
/** For `EntityType.DINGLE` (261), `DingleVariant.DINGLE` (0). */
var DingleSubType;
(function (DingleSubType) {
    /** The non-champion version. */
    DingleSubType[DingleSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. Dingle summons Red Poop instead of Dips. He also dashes four times
     * instead of three, though the dashes are shorter and slower. He also fires blood projectiles
     * instead of poop projectiles, though it is a purely cosmetic effect.
     */
    DingleSubType[DingleSubType["RED"] = 1] = "RED";
    /**
     * The black champion version. Dingle summons spiders instead of Dips and fires eight shots in all
     * directions instead of spitting three at Isaac. He also dashes much faster, but will only dash
     * one time instead of three.
     */
    DingleSubType[DingleSubType["BLACK"] = 2] = "BLACK";
})(DingleSubType || (exports.DingleSubType = DingleSubType = {}));
/** For `EntityType.MEGA_MAW` (262), variant 0. */
var MegaMawSubType;
(function (MegaMawSubType) {
    /** The non-champion version. */
    MegaMawSubType[MegaMawSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. Doesn't shoot any flames or spawn monsters and has a completely
     * different set of blood-shot attacks.
     */
    MegaMawSubType[MegaMawSubType["RED"] = 1] = "RED";
    /**
     * The black champion version. Spits 1-2 spiders instead of Hoppers. The spiders will be tossed
     * directly towards Isaac instead of landing below Mega Maw. It does not use flame attacks.
     */
    MegaMawSubType[MegaMawSubType["BLACK"] = 2] = "BLACK";
})(MegaMawSubType || (exports.MegaMawSubType = MegaMawSubType = {}));
/** For `EntityType.GATE` (263), variant 0. */
var GateSubType;
(function (GateSubType) {
    /** The non-champion version. */
    GateSubType[GateSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. Does not spawn any enemies and has a completely different set of
     * attacks.
     */
    GateSubType[GateSubType["RED"] = 1] = "RED";
    /**
     * The black champion version. Has 25% more HP and spawns Big Spiders instead of Leapers. The Big
     * Spiders are tossed directly towards Isaac instead of landing randomly in the room, and can be
     * damaged by The Gate's blood shots, like the Leapers. It does not perform the Brimstone attack.
     */
    GateSubType[GateSubType["BLACK"] = 2] = "BLACK";
})(GateSubType || (exports.GateSubType = GateSubType = {}));
/** For `EntityType.MEGA_FATTY` (264), variant 0. */
var MegaFattySubType;
(function (MegaFattySubType) {
    /** The non-champion version. */
    MegaFattySubType[MegaFattySubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. 33% smaller and has 10% less HP. Shoots 6 bullets instead of leaving
     * red creep upon landing. Creates Red Poop instead of Dips. Vomit attack sends out four
     * projectiles stream attacks in a pattern similar to Mom's Heart.
     */
    MegaFattySubType[MegaFattySubType["RED"] = 1] = "RED";
    /**
     * The brown champion version. Has 15% more HP. He will not use his vomit attack and sends out
     * rock waves instead of leaving red creep upon landing when performing the long-range jump,
     * similar to The Cage.
     */
    MegaFattySubType[MegaFattySubType["BROWN"] = 2] = "BROWN";
})(MegaFattySubType || (exports.MegaFattySubType = MegaFattySubType = {}));
/** For `EntityType.CAGE` (265), variant 0. */
var CageSubType;
(function (CageSubType) {
    /** The non-champion version. */
    CageSubType[CageSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The green champion version. Periodically leaves puddles of green creep and does not spawn any
     * Vis.
     */
    CageSubType[CageSubType["GREEN"] = 1] = "GREEN";
    /**
     * The pink champion version. Two Cages replace the normal Cage, each with 50% HP. They never
     * perform their jump attack. Both Cages are 50% smaller.
     */
    CageSubType[CageSubType["PINK"] = 2] = "PINK";
})(CageSubType || (exports.CageSubType = CageSubType = {}));
/** For `EntityType.POLYCEPHALUS` (269), `PolycephalusVariant.POLYCEPHALUS` (0). */
var PolycephalusSubType;
(function (PolycephalusSubType) {
    /** The non-champion version. */
    PolycephalusSubType[PolycephalusSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. Summons Para-Bites instead of Round Worms. All projectile attacks are
     * replaced with a ring of six projectiles.
     */
    PolycephalusSubType[PolycephalusSubType["RED"] = 1] = "RED";
    /**
     * The pink champion version. Two Polycephaluses replace the normal Polycephalus, each with 50%
     * HP. They do not spawn Round Worms.
     */
    PolycephalusSubType[PolycephalusSubType["PINK"] = 2] = "PINK";
})(PolycephalusSubType || (exports.PolycephalusSubType = PolycephalusSubType = {}));
/** For `EntityType.STAIN` (401), variant 0. */
var StainSubType;
(function (StainSubType) {
    /** The non-champion version. */
    StainSubType[StainSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The grey champion version. Continuously spawns 2 Round Worms instead of Chargers, with a
     * maximum of 3 at any time. Never fires barrages of bullets.
     */
    StainSubType[StainSubType["GREY"] = 1] = "GREY";
})(StainSubType || (exports.StainSubType = StainSubType = {}));
/** For `EntityType.BROWNIE` (402), variant 0. */
var BrownieSubType;
(function (BrownieSubType) {
    /** The non-champion version. */
    BrownieSubType[BrownieSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The black champion version. Spawns up to 3 Chargers at once instead of Brownie Corns and
     * creates black creep instead of brown creep. The Corn Mines that he spawns are also black.
     * Brownie still leaves green creep when poisoned. When at low health, he becomes 2 Dank Squirts
     * instead of a weakened Dangle.
     */
    BrownieSubType[BrownieSubType["BLACK"] = 1] = "BLACK";
})(BrownieSubType || (exports.BrownieSubType = BrownieSubType = {}));
/** For `EntityType.FORSAKEN` (403), variant 0. */
var ForsakenSubType;
(function (ForsakenSubType) {
    /** The non-champion version. */
    ForsakenSubType[ForsakenSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The black champion version. Spawns Black Bonies instead of regular Bonies. The spinning
     * Brimstone attack is replaced with The Forsaken spawning 4 Dank Death's Heads and resuming
     * invincibility for 1 second if there are no other Dank Death's Heads alive. It can not spawn any
     * Dank Death's Heads if there is at least 1 other alive and will instead remain vulnerable for a
     * duration before spawning another Black Bony.
     */
    ForsakenSubType[ForsakenSubType["BLACK"] = 1] = "BLACK";
})(ForsakenSubType || (exports.ForsakenSubType = ForsakenSubType = {}));
/** For `EntityType.LITTLE_HORN` (404), variant 0. */
var LittleHornSubType;
(function (LittleHornSubType) {
    /** The non-champion version. */
    LittleHornSubType[LittleHornSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The orange champion version. Spits out an orange Troll Bomb instead of a Dark Ball. This Troll
     * Bomb deals contact damage and leaves a patch of fire similar to Hot Bombs that cannot damage
     * him. He also throws these special Troll Bombs into Pitfalls instead of normal ones, and spawns
     * them during the chain teleport attack. He loses 1 HP whenever he spits out a bomb. Does not
     * attack with Mega Troll Bombs.
     */
    LittleHornSubType[LittleHornSubType["ORANGE"] = 1] = "ORANGE";
    /**
     * The black champion version. Does not attack with Pits, Troll Bombs or Mega Troll Bombs, but
     * fires Dark Balls more frequently. This version can still do the chain teleport attack but does
     * not spawn any Troll Bombs.
     */
    LittleHornSubType[LittleHornSubType["BLACK"] = 2] = "BLACK";
})(LittleHornSubType || (exports.LittleHornSubType = LittleHornSubType = {}));
/** For `EntityType.RAG_MAN` (405), variant 0. */
var RagManSubType;
(function (RagManSubType) {
    /** The non-champion version. */
    RagManSubType[RagManSubType["NORMAL"] = 0] = "NORMAL";
    /**
     * The red champion version. Does not fire homing bullets, and instead constantly creates and
     * revives Raglings. The Raglings spawned by this version have the same red color as Rag Man and
     * have 34% less than the normal ones.
     */
    RagManSubType[RagManSubType["RED"] = 1] = "RED";
    /**
     * The black champion version. The head roll attack spawns 1-2 spiders instead of a Ragling. He
     * fires a spray of 3 arcing bullets, instead of a resurrection attack.
     */
    RagManSubType[RagManSubType["BLACK"] = 2] = "BLACK";
})(RagManSubType || (exports.RagManSubType = RagManSubType = {}));
/**
 * For `EntityType.CONSTANT_STONE_SHOOTER` (202),
 * `ConstantStoneShooterVariant.CONSTANT_STONE_SHOOTER` (0).
 *
 * This is the same as the `Direction` enum.
 */
var ConstantStoneShooterSubType;
(function (ConstantStoneShooterSubType) {
    ConstantStoneShooterSubType[ConstantStoneShooterSubType["LEFT"] = 0] = "LEFT";
    ConstantStoneShooterSubType[ConstantStoneShooterSubType["UP"] = 1] = "UP";
    ConstantStoneShooterSubType[ConstantStoneShooterSubType["RIGHT"] = 2] = "RIGHT";
    ConstantStoneShooterSubType[ConstantStoneShooterSubType["DOWN"] = 3] = "DOWN";
})(ConstantStoneShooterSubType || (exports.ConstantStoneShooterSubType = ConstantStoneShooterSubType = {}));
/** For `EntityType.MOTHER` (912), `MotherVariant.MOTHER_1` (0). */
var MotherSubType;
(function (MotherSubType) {
    MotherSubType[MotherSubType["PHASE_1"] = 0] = "PHASE_1";
    MotherSubType[MotherSubType["PHASE_2"] = 1] = "PHASE_2";
})(MotherSubType || (exports.MotherSubType = MotherSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.BLOOD_EXPLOSION` (2). */
var BloodExplosionSubType;
(function (BloodExplosionSubType) {
    BloodExplosionSubType[BloodExplosionSubType["MEDIUM_WITH_LEFTOVER_BLOOD"] = 0] = "MEDIUM_WITH_LEFTOVER_BLOOD";
    BloodExplosionSubType[BloodExplosionSubType["SMALL"] = 1] = "SMALL";
    BloodExplosionSubType[BloodExplosionSubType["MEDIUM"] = 2] = "MEDIUM";
    BloodExplosionSubType[BloodExplosionSubType["LARGE"] = 3] = "LARGE";
    BloodExplosionSubType[BloodExplosionSubType["GIANT"] = 4] = "GIANT";
    BloodExplosionSubType[BloodExplosionSubType["SWIRL"] = 5] = "SWIRL";
})(BloodExplosionSubType || (exports.BloodExplosionSubType = BloodExplosionSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.BLOOD_PARTICLE` (5). */
var GibSubType;
(function (GibSubType) {
    GibSubType[GibSubType["BLOOD"] = 0] = "BLOOD";
    GibSubType[GibSubType["BONE"] = 1] = "BONE";
    GibSubType[GibSubType["GUT"] = 2] = "GUT";
    GibSubType[GibSubType["EYE"] = 3] = "EYE";
})(GibSubType || (exports.GibSubType = GibSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.POOF_1` (15). */
var PoofSubType;
(function (PoofSubType) {
    PoofSubType[PoofSubType["NORMAL"] = 0] = "NORMAL";
    PoofSubType[PoofSubType["SMALL"] = 1] = "SMALL";
    // A sub-type of 2 appears to be the same thing as a sub-type of 0.
    PoofSubType[PoofSubType["LARGE"] = 3] = "LARGE";
})(PoofSubType || (exports.PoofSubType = PoofSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.HEAVEN_LIGHT_DOOR` (39). */
var HeavenLightDoorSubType;
(function (HeavenLightDoorSubType) {
    HeavenLightDoorSubType[HeavenLightDoorSubType["HEAVEN_DOOR"] = 0] = "HEAVEN_DOOR";
    HeavenLightDoorSubType[HeavenLightDoorSubType["MOONLIGHT"] = 1] = "MOONLIGHT";
})(HeavenLightDoorSubType || (exports.HeavenLightDoorSubType = HeavenLightDoorSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.CARPET` (74). */
var CarpetSubType;
(function (CarpetSubType) {
    CarpetSubType[CarpetSubType["ISAACS_CARPET"] = 0] = "ISAACS_CARPET";
    CarpetSubType[CarpetSubType["MOMS_CARPET_1"] = 1] = "MOMS_CARPET_1";
    CarpetSubType[CarpetSubType["MOMS_CARPET_2"] = 2] = "MOMS_CARPET_2";
})(CarpetSubType || (exports.CarpetSubType = CarpetSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.DICE_FLOOR` (76). */
var DiceFloorSubType;
(function (DiceFloorSubType) {
    /** Has the same effect as using a D4. */
    DiceFloorSubType[DiceFloorSubType["ONE_PIP"] = 0] = "ONE_PIP";
    /** Has the same effect as using a D20. */
    DiceFloorSubType[DiceFloorSubType["TWO_PIP"] = 1] = "TWO_PIP";
    /**
     * Rerolls all pickups and trinkets on the floor, including items inside of a shop, excluding
     * collectibles.
     */
    DiceFloorSubType[DiceFloorSubType["THREE_PIP"] = 2] = "THREE_PIP";
    /** Rerolls all collectibles on the floor. */
    DiceFloorSubType[DiceFloorSubType["FOUR_PIP"] = 3] = "FOUR_PIP";
    /** Has the same effect as using a Forget Me Now. */
    DiceFloorSubType[DiceFloorSubType["FIVE_PIP"] = 4] = "FIVE_PIP";
    /** Has the combined effect of a 1-pip, 3-pip and 4-pip dice room. */
    DiceFloorSubType[DiceFloorSubType["SIX_PIP"] = 5] = "SIX_PIP";
})(DiceFloorSubType || (exports.DiceFloorSubType = DiceFloorSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.TALL_LADDER` (156). */
var TallLadderSubType;
(function (TallLadderSubType) {
    TallLadderSubType[TallLadderSubType["TALL_LADDER"] = 0] = "TALL_LADDER";
    TallLadderSubType[TallLadderSubType["STAIRWAY"] = 1] = "STAIRWAY";
})(TallLadderSubType || (exports.TallLadderSubType = TallLadderSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.PORTAL_TELEPORT` (161). */
var PortalTeleportSubType;
(function (PortalTeleportSubType) {
    /** Is yellow in color. */
    PortalTeleportSubType[PortalTeleportSubType["TREASURE_ROOM"] = 0] = "TREASURE_ROOM";
    /** Is red in color. */
    PortalTeleportSubType[PortalTeleportSubType["BOSS_ROOM"] = 1] = "BOSS_ROOM";
    /** Is blue in color. */
    PortalTeleportSubType[PortalTeleportSubType["SECRET_ROOM"] = 2] = "SECRET_ROOM";
    /**
     * Is purple in color.
     *
     * Portals of this type are non-persistent in that they will not respawn if the player leaves the
     * room, which makes them unlike the portals spawned by the Lil Portal familiar. In order to
     * generate Lil-Portal-style portals, you add 1000 to the destination room grid index. For
     * example, you would use a sub-type of 1058 for a persistent portal that always goes to the room
     * at grid index 58.
     */
    PortalTeleportSubType[PortalTeleportSubType["RANDOM_ROOM"] = 3] = "RANDOM_ROOM";
})(PortalTeleportSubType || (exports.PortalTeleportSubType = PortalTeleportSubType = {}));
/** For `EntityType.EFFECT` (1000), `EffectVariant.PURGATORY` (189). */
var PurgatorySubType;
(function (PurgatorySubType) {
    PurgatorySubType[PurgatorySubType["RIFT"] = 0] = "RIFT";
    PurgatorySubType[PurgatorySubType["GHOST"] = 1] = "GHOST";
})(PurgatorySubType || (exports.PurgatorySubType = PurgatorySubType = {}));
