"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DisplayFlagZero = exports.DisplayFlag = void 0;
/**
 * This is represented as an object instead of an enum due to limitations with TypeScript enums. (We
 * want this type to be a child of the `BitFlag` type.)
 *
 * @enum
 * @notExported
 * @rename DisplayFlag
 */
const DisplayFlagInternal = {
    /** 1 << -1 (0) */
    INVISIBLE: 1 << -1,
    /** 1 << 0 (1) */
    VISIBLE: 1 << 0,
    /** 1 << 1 (2) */
    SHADOW: 1 << 1,
    /** 1 << 2 (4) */
    SHOW_ICON: 1 << 2,
};
exports.DisplayFlag = DisplayFlagInternal;
exports.DisplayFlagZero = 0;
