"use strict";
// cspell:ignore STAGEAPI GRIDENTITY
Object.defineProperty(exports, "__esModule", { value: true });
exports.StageAPIPickupRandomGroupVariant = exports.StageAPILayoutSpikesOnOffVariant = exports.StageAPILayoutRockSubtype = exports.StageAPILayoutPoopSubtype = exports.StageAPILayoutPitfallVariant = exports.StageAPILayoutGridType = exports.StageAPILayoutCornyPoopSubtype = exports.StageAPILayoutButtonVariant = exports.StageAPICallback = void 0;
var StageAPICallback;
(function (StageAPICallback) {
    StageAPICallback["POST_CHANGE_ROOM_GFX"] = "POST_CHANGE_ROOM_GFX";
    /** Return false to invalidate a room layout; return integer to specify new weight. */
    StageAPICallback["POST_CHECK_VALID_ROOM"] = "POST_CHECK_VALID_ROOM";
    /**
     * Takes CustomDoorName as first callback parameter, and will only run if parameter not supplied
     * or matches current door.
     */
    StageAPICallback["POST_CUSTOM_DOOR_UPDATE"] = "POST_CUSTOM_DOOR_UPDATE";
    /**
     * Takes CustomGridTypeName as first callback parameter, and will only run if parameter not
     * supplied or matches current grid.
     */
    StageAPICallback["POST_CUSTOM_GRID_PROJECTILE_HELPER_UPDATE"] = "POST_CUSTOM_GRID_PROJECTILE_HELPER_UPDATE";
    /**
     * Takes CustomGridTypeName as first callback parameter, and will only run if parameter not
     * supplied or matches current grid.
     */
    StageAPICallback["POST_CUSTOM_GRID_PROJECTILE_UPDATE"] = "POST_CUSTOM_GRID_PROJECTILE_UPDATE";
    /**
     * Takes CustomGridTypeName as first callback parameter, and will only run if parameter not
     * supplied or matches current grid.
     */
    StageAPICallback["POST_CUSTOM_GRID_REMOVE"] = "POST_CUSTOM_GRID_REMOVE";
    /**
     * Takes CustomGridTypeName as first callback parameter, and will only run if parameter not
     * supplied or matches current grid.
     */
    StageAPICallback["POST_CUSTOM_GRID_UPDATE"] = "POST_CUSTOM_GRID_UPDATE";
    /**
     * Calls when the number of grids changes or grids are reprocessed. This is when room grid
     * graphics are changed.
     */
    StageAPICallback["POST_GRID_UPDATE"] = "POST_GRID_UPDATE";
    /**
     * Called when an overridden grid reaches its break state and is considered broken.
     *
     * @param justBrokenGridSpawns Contains all deleted spawns from the grid.
     *
     * Breaks on first non-undefined return.
     */
    StageAPICallback["POST_OVERRIDDEN_GRID_BREAK"] = "POST_OVERRIDDEN_GRID_BREAK";
    /**
     * Called when a room initializes. Can occur at two times, when a room is initially entered or
     * when a room is loaded from save data. Takes no return values.
     */
    StageAPICallback["POST_ROOM_INIT"] = "POST_ROOM_INIT";
    /** Called when a room is loaded. Takes no return value. */
    StageAPICallback["POST_ROOM_LOAD"] = "POST_ROOM_LOAD";
    /**
     * Takes CustomDoorName as first callback parameter, and will only run if parameter not supplied
     * or matches current door.
     */
    StageAPICallback["POST_SPAWN_CUSTOM_DOOR"] = "POST_SPAWN_CUSTOM_DOOR";
    /**
     * Takes CustomGridTypeName as first callback parameter, and will only run if parameter not
     * supplied or matches current grid.
     */
    StageAPICallback["POST_SPAWN_CUSTOM_GRID"] = "POST_SPAWN_CUSTOM_GRID";
    /**
     * All loading and processing of new room generation and old room loading is done, but the gfx has
     * not changed yet.
     */
    StageAPICallback["POST_STAGEAPI_NEW_ROOM"] = "POST_STAGEAPI_NEW_ROOM";
    /**
     * Allows returning justGenerated and currentRoom. Run after normal room generation but before
     * reloading old rooms.
     */
    StageAPICallback["POST_STAGEAPI_NEW_ROOM_GENERATION"] = "POST_STAGEAPI_NEW_ROOM_GENERATION";
    /** If a boss is returned, uses it instead. */
    StageAPICallback["PRE_BOSS_SELECT"] = "PRE_BOSS_SELECT";
    /** Allows returning room gfx to use in place of the stage's. */
    StageAPICallback["PRE_CHANGE_ROOM_GFX"] = "PRE_CHANGE_ROOM_GFX";
    /**
     * Takes 1 return value. If a table, uses it as the current room layout. Otherwise, chooses from
     * `roomsList` with seeded RNG. Breaks on first return.
     *
     * Called both on initial room load and when continuing game, before INIT.
     */
    StageAPICallback["PRE_ROOM_LAYOUT_CHOOSE"] = "PRE_ROOM_LAYOUT_CHOOSE";
    /**
     * - Takes 4 return values, AddEntities, EntityList, StillAddRandom, and NoBreak.
     * - If the first value is false, cancels selecting the list.
     * - AddEntities and EntityList are lists of EntityData tables, described below.
     * - Usually StageAPI will pick one entity from the EntityList to add to the AddEntities table at
     *   random, but that can be changed with this callback.
     * - If StillAddRandom is true, StageAPI will still add a random entity from the entityList to
     *   addEntities, alongside ones you returned.
     */
    StageAPICallback["PRE_SELECT_ENTITY_LIST"] = "PRE_SELECT_ENTITY_LIST";
    /**
     * Takes 1 return value. If false, cancels selecting the list. If GridData, selects it to spawn.
     * With no value, picks at random.
     */
    StageAPICallback["PRE_SELECT_GRIDENTITY_LIST"] = "PRE_SELECT_GRIDENTITY_LIST";
    /** Return a stage to go to instead of currentStage.NextStage or none. */
    StageAPICallback["PRE_SELECT_NEXT_STAGE"] = "PRE_SELECT_NEXT_STAGE";
    /**
     * Takes 1 return value. If false, cancels spawning the entity info. If a table, uses it as the
     * entity info. Any return value breaks out of future callbacks.
     */
    StageAPICallback["PRE_SPAWN_ENTITY"] = "PRE_SPAWN_ENTITY";
    /**
     * Takes 1 return value. If false, cancels spawning the entity list. If a table, uses it as the
     * entity list. Any return value breaks out of future callbacks. Every entity in the final entity
     * list is spawned. Note that this entity list contains EntityInfo tables rather than EntityData,
     * which contain persistent room-specific data. Both detailed below.
     */
    StageAPICallback["PRE_SPAWN_ENTITY_LIST"] = "PRE_SPAWN_ENTITY_LIST";
    /**
     * Takes 1 return value. If `false`, cancels spawning the grid. If a table, uses it as the grid
     * data.
     *
     * Any return value breaks out of future callbacks.
     */
    StageAPICallback["PRE_SPAWN_GRID"] = "PRE_SPAWN_GRID";
    /**
     * Runs before most but not all stageapi room functionality. Guaranteed to run before any room
     * loads.
     */
    StageAPICallback["PRE_STAGEAPI_NEW_ROOM"] = "PRE_STAGEAPI_NEW_ROOM";
    /**
     * Called before the custom room transition would render, for effects that should render before
     * it.
     */
    StageAPICallback["PRE_TRANSITION_RENDER"] = "PRE_TRANSITION_RENDER";
    /** Allows returning grid gfx to use in place of the stage's. */
    StageAPICallback["PRE_UPDATE_GRID_GFX"] = "PRE_UPDATE_GRID_GFX";
})(StageAPICallback || (exports.StageAPICallback = StageAPICallback = {}));
var StageAPILayoutButtonVariant;
(function (StageAPILayoutButtonVariant) {
    StageAPILayoutButtonVariant[StageAPILayoutButtonVariant["ROOM_CLEAR"] = 0] = "ROOM_CLEAR";
    StageAPILayoutButtonVariant[StageAPILayoutButtonVariant["REWARD"] = 1] = "REWARD";
    StageAPILayoutButtonVariant[StageAPILayoutButtonVariant["GREED"] = 2] = "GREED";
    StageAPILayoutButtonVariant[StageAPILayoutButtonVariant["KILL"] = 9] = "KILL";
    StageAPILayoutButtonVariant[StageAPILayoutButtonVariant["RAIL"] = 3] = "RAIL";
})(StageAPILayoutButtonVariant || (exports.StageAPILayoutButtonVariant = StageAPILayoutButtonVariant = {}));
var StageAPILayoutCornyPoopSubtype;
(function (StageAPILayoutCornyPoopSubtype) {
    StageAPILayoutCornyPoopSubtype[StageAPILayoutCornyPoopSubtype["NORMAL"] = 0] = "NORMAL";
    StageAPILayoutCornyPoopSubtype[StageAPILayoutCornyPoopSubtype["NON_REPLACEABLE"] = 1] = "NON_REPLACEABLE";
})(StageAPILayoutCornyPoopSubtype || (exports.StageAPILayoutCornyPoopSubtype = StageAPILayoutCornyPoopSubtype = {}));
var StageAPILayoutGridType;
(function (StageAPILayoutGridType) {
    StageAPILayoutGridType[StageAPILayoutGridType["ROCK"] = 1000] = "ROCK";
    StageAPILayoutGridType[StageAPILayoutGridType["ROCK_ALT"] = 1002] = "ROCK_ALT";
    StageAPILayoutGridType[StageAPILayoutGridType["ROCK_BOMB"] = 1001] = "ROCK_BOMB";
    StageAPILayoutGridType[StageAPILayoutGridType["ROCK_SPIKE"] = 1010] = "ROCK_SPIKE";
    StageAPILayoutGridType[StageAPILayoutGridType["ROCK_GOLD"] = 1011] = "ROCK_GOLD";
    StageAPILayoutGridType[StageAPILayoutGridType["MARKED_SKULL"] = 1008] = "MARKED_SKULL";
    StageAPILayoutGridType[StageAPILayoutGridType["BLOCK_METAL"] = 1900] = "BLOCK_METAL";
    StageAPILayoutGridType[StageAPILayoutGridType["BLOCK_METAL_TALL"] = 1901] = "BLOCK_METAL_TALL";
    StageAPILayoutGridType[StageAPILayoutGridType["BLOCK_INVISIBLE"] = 1999] = "BLOCK_INVISIBLE";
    StageAPILayoutGridType[StageAPILayoutGridType["BLOCK_KEY"] = 4000] = "BLOCK_KEY";
    StageAPILayoutGridType[StageAPILayoutGridType["PIT"] = 3000] = "PIT";
    StageAPILayoutGridType[StageAPILayoutGridType["TNT"] = 1300] = "TNT";
    StageAPILayoutGridType[StageAPILayoutGridType["TNT_PUSHABLE"] = 292] = "TNT_PUSHABLE";
    StageAPILayoutGridType[StageAPILayoutGridType["SPIKES"] = 1930] = "SPIKES";
    StageAPILayoutGridType[StageAPILayoutGridType["SPIKES_ON_OFF"] = 1931] = "SPIKES_ON_OFF";
    StageAPILayoutGridType[StageAPILayoutGridType["COBWEB"] = 1940] = "COBWEB";
    StageAPILayoutGridType[StageAPILayoutGridType["BUTTON"] = 4500] = "BUTTON";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP"] = 1500] = "POOP";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP_CORNY"] = 1495] = "POOP_CORNY";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP_RED"] = 1490] = "POOP_RED";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP_GOLD"] = 1496] = "POOP_GOLD";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP_RAINBOW"] = 1494] = "POOP_RAINBOW";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP_BLACK"] = 1497] = "POOP_BLACK";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP_HOLY"] = 1498] = "POOP_HOLY";
    StageAPILayoutGridType[StageAPILayoutGridType["POOP_CHARMING"] = 1501] = "POOP_CHARMING";
    StageAPILayoutGridType[StageAPILayoutGridType["GRAVITY"] = 10000] = "GRAVITY";
    StageAPILayoutGridType[StageAPILayoutGridType["PITFALL"] = 291] = "PITFALL";
    StageAPILayoutGridType[StageAPILayoutGridType["PROP_A"] = 10] = "PROP_A";
    StageAPILayoutGridType[StageAPILayoutGridType["PROP_B"] = 20] = "PROP_B";
    StageAPILayoutGridType[StageAPILayoutGridType["PROP_C"] = 30] = "PROP_C";
})(StageAPILayoutGridType || (exports.StageAPILayoutGridType = StageAPILayoutGridType = {}));
var StageAPILayoutPitfallVariant;
(function (StageAPILayoutPitfallVariant) {
    StageAPILayoutPitfallVariant[StageAPILayoutPitfallVariant["NORMAL"] = 0] = "NORMAL";
    StageAPILayoutPitfallVariant[StageAPILayoutPitfallVariant["SUCTION"] = 1] = "SUCTION";
    StageAPILayoutPitfallVariant[StageAPILayoutPitfallVariant["TELEPORT"] = 2] = "TELEPORT";
})(StageAPILayoutPitfallVariant || (exports.StageAPILayoutPitfallVariant = StageAPILayoutPitfallVariant = {}));
var StageAPILayoutPoopSubtype;
(function (StageAPILayoutPoopSubtype) {
    StageAPILayoutPoopSubtype[StageAPILayoutPoopSubtype["NORMAL"] = 0] = "NORMAL";
    StageAPILayoutPoopSubtype[StageAPILayoutPoopSubtype["NON_REPLACEABLE"] = 1] = "NON_REPLACEABLE";
})(StageAPILayoutPoopSubtype || (exports.StageAPILayoutPoopSubtype = StageAPILayoutPoopSubtype = {}));
var StageAPILayoutRockSubtype;
(function (StageAPILayoutRockSubtype) {
    StageAPILayoutRockSubtype[StageAPILayoutRockSubtype["NORMAL"] = 0] = "NORMAL";
    StageAPILayoutRockSubtype[StageAPILayoutRockSubtype["NON_REPLACEABLE"] = 1] = "NON_REPLACEABLE";
})(StageAPILayoutRockSubtype || (exports.StageAPILayoutRockSubtype = StageAPILayoutRockSubtype = {}));
var StageAPILayoutSpikesOnOffVariant;
(function (StageAPILayoutSpikesOnOffVariant) {
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["NORMAL"] = 0] = "NORMAL";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["DOWN_1_FIFTH"] = 1] = "DOWN_1_FIFTH";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["DOWN_2_FIFTHS"] = 2] = "DOWN_2_FIFTHS";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["DOWN_3_FIFTHS"] = 3] = "DOWN_3_FIFTHS";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["DOWN_4_FIFTHS"] = 4] = "DOWN_4_FIFTHS";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["DOWN_5_FIFTHS"] = 5] = "DOWN_5_FIFTHS";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["UP_1_FIFTH"] = 6] = "UP_1_FIFTH";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["UP_2_FIFTHS"] = 7] = "UP_2_FIFTHS";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["UP_3_FIFTHS"] = 8] = "UP_3_FIFTHS";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["UP_4_FIFTHS"] = 9] = "UP_4_FIFTHS";
    StageAPILayoutSpikesOnOffVariant[StageAPILayoutSpikesOnOffVariant["UP_5_FIFTHS"] = 10] = "UP_5_FIFTHS";
})(StageAPILayoutSpikesOnOffVariant || (exports.StageAPILayoutSpikesOnOffVariant = StageAPILayoutSpikesOnOffVariant = {}));
var StageAPIPickupRandomGroupVariant;
(function (StageAPIPickupRandomGroupVariant) {
    StageAPIPickupRandomGroupVariant[StageAPIPickupRandomGroupVariant["ANY"] = 0] = "ANY";
    StageAPIPickupRandomGroupVariant[StageAPIPickupRandomGroupVariant["NOT_CHEST_ITEM"] = 1] = "NOT_CHEST_ITEM";
    StageAPIPickupRandomGroupVariant[StageAPIPickupRandomGroupVariant["NOT_ITEM"] = 2] = "NOT_ITEM";
    StageAPIPickupRandomGroupVariant[StageAPIPickupRandomGroupVariant["NOT_CHEST_ITEM_COIN"] = 3] = "NOT_CHEST_ITEM_COIN";
    StageAPIPickupRandomGroupVariant[StageAPIPickupRandomGroupVariant["NOT_CHEST_ITEM_TRINKET"] = 4] = "NOT_CHEST_ITEM_TRINKET";
})(StageAPIPickupRandomGroupVariant || (exports.StageAPIPickupRandomGroupVariant = StageAPIPickupRandomGroupVariant = {}));
